package com.ruoyi.web.controller.app;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.wx.vo.PrepayResponseVO;
import com.ruoyi.system.order.domain.EOrderQuery;
import com.ruoyi.system.order.domain.dto.EOrderDTO;
import com.ruoyi.system.order.service.IEOrderService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * 订单Controller
 * @author 辉
 * 2024/3/5
 */
@Api(tags = "订单")
@RestController
@RequestMapping("/app/order")
public class AppOrderController extends BaseController {

    @Autowired
    private IEOrderService orderService;

    /**
     * 下单
     */
    @Log(title = "下单", businessType = BusinessType.CREATEORDER)
    @PostMapping("/createOrder")
    public AjaxResult createOrder(@RequestBody @Validated EOrderDTO order)
    {
        logger.info("【下单】请求参数：order={}", JSON.toJSON(order));
        PrepayResponseVO orderServiceOrder = orderService.createOrder(order);
        return success(orderServiceOrder);
    }


}
