package com.ruoyi.web.controller.app;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.service.IERoomService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 房间Controller
 * @author 辉
 * 2024/3/5
 */
@Api(tags = "房间")
@RestController
@RequestMapping("/app/room")
public class AppRoomController extends BaseController {

    @Autowired
    private IERoomService roomService;

    /**
     * 获取房间详细信息
     */
    @GetMapping(value = "/{roomId}")
    public AjaxResult getRoomInfo(@PathVariable("roomId") Long roomId)
    {
        logger.info("获取房间详细信息：【roomId={}】", roomId);
        return success(roomService.selectERoomByRoomId(roomId));
    }

    /**
     * 开房间门
     */
    @GetMapping(value = "/openRoomGate/{roomId}")
    public AjaxResult openRoomGate(@PathVariable("roomId") Long roomId)
    {
        logger.info("开房间门：【roomId={}】", roomId);
        return success(roomService.openGate(roomId));
    }


}
