package com.ruoyi.web.controller.app;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.rule.EFeeRuleVO;
import com.ruoyi.system.service.IEFeeRuleService;
import com.ruoyi.system.service.IERoomService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 套餐Controller
 * @author 辉
 * 2024/3/5
 */
@Api(tags = "套餐")
@RestController
@RequestMapping("/app/rule")
public class AppRuleController extends BaseController {

    @Autowired
    private IEFeeRuleService feeRuleService;

    /**
     * 根据房间id获取套餐
     */
    @GetMapping("/getListByRoomId")
    public AjaxResult ruleList(Long roomId)
    {
        logger.info("根据房间id获取套餐：【roomId={}】", roomId);
        List<EFeeRuleVO> list = feeRuleService.selectEFeeRuleListByRoomId(roomId);
        return success(list);
    }



}
