package com.ruoyi.system.balance.mapper;

import java.util.List;
import com.ruoyi.system.balance.domain.EUserBalance;
import com.ruoyi.system.balance.domain.EUserBalanceVO;
import com.ruoyi.system.balance.domain.EUserBalanceQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 用户余额Mapper接口
 *
 * @author qzz
 * @date 2024-11-26
 */
public interface EUserBalanceMapper
{
    /**
     * 查询用户余额
     *
     * @param balanceId 用户余额主键
     * @return 用户余额
     */
    public EUserBalanceVO selectEUserBalanceByBalanceId(Long balanceId);

    /**
     * 查询用户余额列表
     *
     * @param query 用户余额
     * @return 用户余额集合
     */
    public List<EUserBalanceVO> selectEUserBalanceList(@Param("query")EUserBalanceQuery query);

    /**
     * 新增用户余额
     *
     * @param eUserBalance 用户余额
     * @return 结果
     */
    public int insertEUserBalance(EUserBalance eUserBalance);

    /**
     * 修改用户余额
     *
     * @param eUserBalance 用户余额
     * @return 结果
     */
    public int updateEUserBalance(@Param("data") EUserBalance eUserBalance);

    /**
     * 删除用户余额
     *
     * @param balanceId 用户余额主键
     * @return 结果
     */
    public int deleteEUserBalanceByBalanceId(Long balanceId);

    /**
     * 批量删除用户余额
     *
     * @param balanceIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEUserBalanceByBalanceIds(Long[] balanceIds);
}
