package com.ruoyi.system.balance.service;

import java.util.List;
import com.ruoyi.system.balance.domain.EUserBalance;
import com.ruoyi.system.balance.domain.EUserBalanceVO;
import com.ruoyi.system.balance.domain.EUserBalanceQuery;

/**
 * 用户余额Service接口
 *
 * @author qzz
 * @date 2024-11-26
 */
public interface IEUserBalanceService
{
    /**
     * 查询用户余额
     *
     * @param balanceId 用户余额主键
     * @return 用户余额
     */
    public EUserBalanceVO selectEUserBalanceByBalanceId(Long balanceId);

    /**
     * 查询用户余额列表
     *
     * @param eUserBalance 用户余额
     * @return 用户余额集合
     */
    public List<EUserBalanceVO> selectEUserBalanceList(EUserBalanceQuery eUserBalance);

    /**
     * 新增用户余额
     *
     * @param eUserBalance 用户余额
     * @return 结果
     */
    public int insertEUserBalance(EUserBalance eUserBalance);

    /**
     * 修改用户余额
     *
     * @param eUserBalance 用户余额
     * @return 结果
     */
    public int updateEUserBalance(EUserBalance eUserBalance);

    /**
     * 批量删除用户余额
     *
     * @param balanceIds 需要删除的用户余额主键集合
     * @return 结果
     */
    public int deleteEUserBalanceByBalanceIds(Long[] balanceIds);

    /**
     * 删除用户余额信息
     *
     * @param balanceId 用户余额主键
     * @return 结果
     */
    public int deleteEUserBalanceByBalanceId(Long balanceId);
}
