package com.ruoyi.system.balance.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.system.balance.mapper.EUserBalanceMapper;
import com.ruoyi.system.balance.domain.EUserBalance;
import com.ruoyi.system.balance.domain.EUserBalanceVO;
import com.ruoyi.system.balance.domain.EUserBalanceQuery;
import com.ruoyi.system.balance.service.IEUserBalanceService;

/**
 * 用户余额Service业务层处理
 *
 * @author qzz
 * @date 2024-11-26
 */
@Service
public class EUserBalanceServiceImpl implements IEUserBalanceService
{
    @Autowired
    private EUserBalanceMapper eUserBalanceMapper;

    /**
     * 查询用户余额
     *
     * @param balanceId 用户余额主键
     * @return 用户余额
     */
    @Override
    public EUserBalanceVO selectEUserBalanceByBalanceId(Long balanceId)
    {
        return eUserBalanceMapper.selectEUserBalanceByBalanceId(balanceId);
    }

    /**
     * 查询用户余额列表
     *
     * @param eUserBalance 用户余额
     * @return 用户余额
     */
    @Override
    public List<EUserBalanceVO> selectEUserBalanceList(EUserBalanceQuery eUserBalance)
    {
        return eUserBalanceMapper.selectEUserBalanceList(eUserBalance);
    }

    /**
     * 新增用户余额
     *
     * @param eUserBalance 用户余额
     * @return 结果
     */
    @Override
    public int insertEUserBalance(EUserBalance eUserBalance)
    {
        return eUserBalanceMapper.insertEUserBalance(eUserBalance);
    }

    /**
     * 修改用户余额
     *
     * @param eUserBalance 用户余额
     * @return 结果
     */
    @Override
    public int updateEUserBalance(EUserBalance eUserBalance)
    {
        return eUserBalanceMapper.updateEUserBalance(eUserBalance);
    }

    /**
     * 批量删除用户余额
     *
     * @param balanceIds 需要删除的用户余额主键
     * @return 结果
     */
    @Override
    public int deleteEUserBalanceByBalanceIds(Long[] balanceIds)
    {
        return eUserBalanceMapper.deleteEUserBalanceByBalanceIds(balanceIds);
    }

    /**
     * 删除用户余额信息
     *
     * @param balanceId 用户余额主键
     * @return 结果
     */
    @Override
    public int deleteEUserBalanceByBalanceId(Long balanceId)
    {
        return eUserBalanceMapper.deleteEUserBalanceByBalanceId(balanceId);
    }
}
