package com.ruoyi.system.bonus.domain.enums;

import com.ruoyi.common.exception.ServiceException;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Objects;

/**
 * @author wjh
 * 2024/8/21
 */
@Getter
@AllArgsConstructor
public enum UserType {

    MCH("01", "商户"),
    MANAGER("02", "店长"),
    CLERK("03", "店员"),
    CLEANER("04", "保洁"),
    PLATFORM("09", "平台");

    private final String type;
    private final String msg;

    // 转换
    public static UserType parse(String type) {
        for (UserType value : UserType.values()) {
            if (value.getType().equals(type)) {
                return value;
            }
        }
        throw new ServiceException("不存在的用户类型");
    }

    public boolean equalsType(String type) {
        return Objects.equals(this.type, type);
    }

    // 判断该类型是否存在
    public static boolean contains(String type) {
        for (UserType value : UserType.values()) {
            if (value.getType().equals(type)) {
                return true;
            }
        }
        return false;
    }
}
