package com.ruoyi.system.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;
import java.util.Date;

/**
 * 共享钥匙对象 e_share_key
 *
 * @author 邱贞招
 * @date 2024-07-31
 */
@Data
public class EShareKey extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** id */
    private Long keyId;

    /** 钥匙名称 */
    @Excel(name = "钥匙名称")
    private String keyName;

    /** 分享用户 */
    @Excel(name = "分享用户")
    private Long shareId;

    /** 分享用户电话 */
    @Excel(name = "分享用户电话")
    private String sharePhone;

    /** 分享用户 */
    @Excel(name = "分享用户")
    private String shareUserName;

    /** 车辆归属用户 */
    @Excel(name = "车辆归属用户")
    private Long ownerId;

    /** 车辆用户名称 */
    @Excel(name = "归属用户名称")
    private String ownerName;

    /** 车辆用户名称 */
    @Excel(name = "归属用户名称")
    private String ownerPhone;

    /** sn */
    @Excel(name = "sn")
    private String sn;

    /** 钥匙状态 */
    @Excel(name = "钥匙状态")
    private String status;

    /** 有效时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "有效时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    private Date expirationTime;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;


}
