package com.ruoyi.system.domain.address;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import lombok.Data;

/**
 * 用户地址对象 e_user_address
 *
 * @author qzz
 * @date 2024-11-09
 */
@Data
public class EUserAddress extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 用户地址id */
    private Long id;

    /** 用户id */
    @Excel(name = "用户id")
    private Integer uid;

    /** 收货人姓名 */
    @Excel(name = "收货人姓名")
    private String realName;

    /** 收货人电话 */
    @Excel(name = "收货人电话")
    private String phone;

    /** 收货人所在省 */
    @Excel(name = "收货人所在省")
    private String province;

    /** 收货人所在市 */
    @Excel(name = "收货人所在市")
    private String city;

    /** 城市id */
    @Excel(name = "城市id")
    private Long cityId;

    /** 收货人所在区 */
    @Excel(name = "收货人所在区")
    private String district;

    /** 收货人详细地址 */
    @Excel(name = "收货人详细地址")
    private String detail;

    /** 邮编 */
    @Excel(name = "邮编")
    private Integer postCode;

    /** 经度 */
    @Excel(name = "经度")
    private String longitude;

    /** 纬度 */
    @Excel(name = "纬度")
    private String latitude;

    /** 是否默认 */
    @Excel(name = "是否默认")
    private Integer isDefault;

    /** 是否删除 */
    private Integer isDel;

}
