package com.ruoyi.system.domain.clean;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 保洁记录对象 e_clean
 *
 * @author qzz
 * @date 2024-11-19
 */
@Data
public class EClean extends BaseEntity {
        private static final long serialVersionUID = 1L;

        private Long cleanId;

        @Excel(name = "用户id")
        @ApiModelProperty("用户id")
        private Long userId;

        @Excel(name = "保洁员姓名")
        @ApiModelProperty("保洁员姓名")
        private String userName;

        @Excel(name = "电话")
        @ApiModelProperty("电话")
        private String userPhone;

        @Excel(name = "房间id")
        @ApiModelProperty("房间id")
        private Long roomId;

        @Excel(name = "房间名")
        @ApiModelProperty("房间名")
        private String roomName;

        @Excel(name = "状态")
        @ApiModelProperty("状态")
        private String status;

        @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
        @Excel(name = "开始时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
        @ApiModelProperty("开始时间")
        private Date startTime;

        @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
        @Excel(name = "结束时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
        @ApiModelProperty("结束时间")
        private Date endTime;

        @Excel(name = "商户id")
        @ApiModelProperty("商户id")
        private Long merchantId;

}
