package com.ruoyi.system.domain.room;

import com.ruoyi.common.core.domain.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

/**
 * 房间对象 e_room
 *
 * @author qzz
 * @date 2024-11-20
 */
@Data
public class ERoom extends BaseEntity{

    private static final long serialVersionUID = 1L;

    private Long roomId;

    @Excel(name = "房间名")
    @ApiModelProperty("房间名")
    private String roomName;

    private Long storeId;

    @Excel(name = "店铺")
    @ApiModelProperty("店铺")
    private String storeName;

    @Excel(name = "类型")
    @ApiModelProperty("类型")
    private String type;

    @Excel(name = "图片")
    @ApiModelProperty("图片")
    private String picture;

    @Excel(name = "标签列表")
    @ApiModelProperty("标签列表")
    @NotNull(message = "标签列表不允许为空", groups = {ValidGroup.Create.class})
    @Size(min = 1, message = "至少需要一个标签", groups = {ValidGroup.Create.class})
    private List<String> tags;

    @Excel(name = "规格")
    @ApiModelProperty("规格")
    private String specification;

    @Excel(name = "状态")
    @ApiModelProperty("状态")
    private String status;

    @Excel(name = "商户id")
    @ApiModelProperty("商户id")
    private Long merchantId;

    @Excel(name = "大门id(用于控制大门锁)")
    @ApiModelProperty("大门id(用于控制大门锁)")
    private Long gateId;

}
