package com.ruoyi.system.domain.store;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * 店铺对象 e_store
 *
 * @author qzz
 * @date 2024-11-20
 */
@Data
public class EStore extends BaseEntity{

    private static final long serialVersionUID = 1L;

    private Long storeId;

    @Excel(name = "店铺名称")
    @ApiModelProperty("店铺名称")
    private String name;

    @Excel(name = "联系人")
    @ApiModelProperty("联系人")
    private String contactName;

    @Excel(name = "联系电话")
    @ApiModelProperty("联系电话")
    private String contactMobile;

    @Excel(name = "身份证号")
    @ApiModelProperty("身份证号")
    private String idcard;

    @Excel(name = "商户图片")
    @ApiModelProperty("商户图片")
    private String picture;

    @Excel(name = "门店地址")
    @ApiModelProperty("门店地址")
    private String address;

    @Excel(name = "定位经度")
    @ApiModelProperty("定位经度")
    private BigDecimal lng;

    @Excel(name = "定位纬度")
    @ApiModelProperty("定位纬度")
    private BigDecimal lat;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "营业时间起始", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("营业时间起始")
    private Date businessTimeStart;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "营业时间结束", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("营业时间结束")
    private Date businessTimeEnd;

    @Excel(name = "省")
    @ApiModelProperty("省")
    private String province;

    @Excel(name = "市")
    @ApiModelProperty("市")
    private String city;

    @Excel(name = "区县")
    @ApiModelProperty("区县")
    private String county;

    @Excel(name = "客服电话")
    @ApiModelProperty("客服电话")
    private String serverPhone;

    @Excel(name = "地址")
    @ApiModelProperty("地址")
    private String simpleAddress;

    @Excel(name = "商户id")
    @ApiModelProperty("商户id")
    private Long merchantId;

    @Excel(name = "状态")
    @ApiModelProperty("状态")
    private String status;

    @Excel(name = "大门sn(用于控制大门锁)")
    @ApiModelProperty("大门sn(用于控制大门锁)")
    private String gateSn;

    @Excel(name = "大门id(用于控制大门锁)")
    @ApiModelProperty("大门id(用于控制大门锁)")
    private Long gateId;

    @Excel(name = "店长id")
    @ApiModelProperty("店长id")
    private Long managerId;

    @Excel(name = "店长名称")
    @ApiModelProperty("店长名称")
    private String managerName;

    @Excel(name = "城市id")
    @ApiModelProperty("城市id")
    private Long cityId;

    @Excel(name = "标签列表")
    @ApiModelProperty("标签列表")
    @NotNull(message = "标签列表不允许为空", groups = {ValidGroup.Create.class})
    @Size(min = 1, message = "至少需要一个标签", groups = {ValidGroup.Create.class})
    private List<String> tags;

}
