package com.ruoyi.system.domain.userWithdraw;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 用户提现渠道对象 e_user_withdraw
 *
 * @author qzz
 * @date 2024-10-21
 */
@Data
public class EUserWithdraw extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** id */
    private Long userChannelId;

    /** 用户 */
    @Excel(name = "用户")
    private Long userId;

    /** 提现渠道ID */
    @Excel(name = "提现渠道ID")
    private Long channelId;

    /** 渠道名称 */
    @Excel(name = "渠道名称")
    private String name;

    /** 提现手续费类型：1-按比例，2-按每笔 */
    @Excel(name = "提现手续费类型：1-按比例，2-按每笔")
    private String handlingChargeType;

    /** 提现手续费 */
    @Excel(name = "提现手续费")
    private BigDecimal withdrawHandlingCharge;

    /** 单笔最低提现金额 */
    @Excel(name = "单笔最低提现金额")
    private BigDecimal minAmount;

    /** 单笔最高提现金额 */
    @Excel(name = "单笔最高提现金额")
    private BigDecimal maxAmount;

    /** 是否开通 */
    @Excel(name = "是否开通")
    private Boolean isOpen;

    /** 渠道图片 */
    @Excel(name = "渠道图片")
    private String picture;

    /** 收款码 */
    @Excel(name = "收款码")
    private String collectionCode;

    /** 是否需要上传收款码：0-不需要；1-需要 */
    @Excel(name = "是否需要上传收款码")
    private Boolean isNeedCode;

}
