package com.ruoyi.system.domain.vo;

import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

/**
 * app首页统计
 *
 * @author 邱贞招
 * @date 2024-05-09
 */
@Data
public class IndexAdminVo {

    /** 收入统计list */
    private List<IncomeVo> incomeVoList;

    /** 车辆统计 */
    private DeviceVO deviceVO;

    /**
     * 7日营收
     */
    @Data
    public static class IncomeVo {
        /** 日期 */
        private String day;
        /** 订单金额 */
        private BigDecimal orderFee;
        /** 订单数 */
        private Integer orderNum;
    }

    @Data
    public static class DeviceVO {
        /** 车辆总数 */
        private Integer total;
        /** 空闲中 */
        private Integer idle;
        /** 出租中 */
        private Integer rent;
    }

    /** 今日营收 */
    private BigDecimal todayIncome;

    /** 今日订单数 */
    private Integer todayOrderNum;

    /** 较昨日营收 */
    private BigDecimal comparedYesterdayIncome;

    /** 较昨日订单数 */
    private BigDecimal comparedYesterdayOrderNum;

}
