package com.ruoyi.system.intention.mapper;

import java.util.List;
import com.ruoyi.system.intention.domain.EIntention;
import com.ruoyi.system.intention.domain.EIntentionVO;
import com.ruoyi.system.intention.domain.EIntentionQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 合作意向Mapper接口
 *
 * @author qzz
 * @date 2024-11-21
 */
public interface EIntentionMapper
{
    /**
     * 查询合作意向
     *
     * @param intentionId 合作意向主键
     * @return 合作意向
     */
    public EIntentionVO selectEIntentionByIntentionId(Long intentionId);

    /**
     * 查询合作意向列表
     *
     * @param query 合作意向
     * @return 合作意向集合
     */
    public List<EIntentionVO> selectEIntentionList(@Param("query")EIntentionQuery query);

    /**
     * 新增合作意向
     *
     * @param eIntention 合作意向
     * @return 结果
     */
    public int insertEIntention(EIntention eIntention);

    /**
     * 修改合作意向
     *
     * @param eIntention 合作意向
     * @return 结果
     */
    public int updateEIntention(@Param("data") EIntention eIntention);

    /**
     * 删除合作意向
     *
     * @param intentionId 合作意向主键
     * @return 结果
     */
    public int deleteEIntentionByIntentionId(Long intentionId);

    /**
     * 批量删除合作意向
     *
     * @param intentionIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEIntentionByIntentionIds(Long[] intentionIds);
}
