package com.ruoyi.system.intention.service;

import java.util.List;
import com.ruoyi.system.intention.domain.EIntention;
import com.ruoyi.system.intention.domain.EIntentionVO;
import com.ruoyi.system.intention.domain.EIntentionQuery;

/**
 * 合作意向Service接口
 *
 * @author qzz
 * @date 2024-11-21
 */
public interface IEIntentionService
{
    /**
     * 查询合作意向
     *
     * @param intentionId 合作意向主键
     * @return 合作意向
     */
    public EIntentionVO selectEIntentionByIntentionId(Long intentionId);

    /**
     * 查询合作意向列表
     *
     * @param eIntention 合作意向
     * @return 合作意向集合
     */
    public List<EIntentionVO> selectEIntentionList(EIntentionQuery eIntention);

    /**
     * 新增合作意向
     *
     * @param eIntention 合作意向
     * @return 结果
     */
    public int insertEIntention(EIntention eIntention);

    /**
     * 修改合作意向
     *
     * @param eIntention 合作意向
     * @return 结果
     */
    public int updateEIntention(EIntention eIntention);

    /**
     * 批量删除合作意向
     *
     * @param intentionIds 需要删除的合作意向主键集合
     * @return 结果
     */
    public int deleteEIntentionByIntentionIds(Long[] intentionIds);

    /**
     * 删除合作意向信息
     *
     * @param intentionId 合作意向主键
     * @return 结果
     */
    public int deleteEIntentionByIntentionId(Long intentionId);
}
