package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.rule.EFeeRule;
import com.ruoyi.system.domain.rule.EFeeRuleVO;
import com.ruoyi.system.domain.rule.EFeeRuleQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 收费模板Mapper接口
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface EFeeRuleMapper
{
    /**
     * 查询收费模板
     *
     * @param ruleId 收费模板主键
     * @return 收费模板
     */
    public EFeeRuleVO selectEFeeRuleByRuleId(Long ruleId);

    /**
     * 查询收费模板列表
     *
     * @param query 收费模板
     * @return 收费模板集合
     */
    public List<EFeeRuleVO> selectEFeeRuleList(@Param("query")EFeeRuleQuery query);

    /**
     * 新增收费模板
     *
     * @param eFeeRule 收费模板
     * @return 结果
     */
    public int insertEFeeRule(EFeeRule eFeeRule);

    /**
     * 修改收费模板
     *
     * @param eFeeRule 收费模板
     * @return 结果
     */
    public int updateEFeeRule(@Param("data") EFeeRule eFeeRule);

    /**
     * 删除收费模板
     *
     * @param ruleId 收费模板主键
     * @return 结果
     */
    public int deleteEFeeRuleByRuleId(Long ruleId);

    /**
     * 批量删除收费模板
     *
     * @param ruleIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEFeeRuleByRuleIds(Long[] ruleIds);

    /**
     * 根据房间id获取套餐
     */
    List<EFeeRuleVO> selectEFeeRuleListByRoomId(Long roomId);
}
