package com.ruoyi.system.mapper;

import com.ruoyi.system.domain.EHardwareVersion;

import java.util.List;

/**
 * 硬件版本Mapper接口
 *
 * @author qiuzhenzhao
 * @date 2024-07-22
 */
public interface EHardwareVersionMapper
{
    /**
     * 查询硬件版本
     *
     * @param id 硬件版本主键
     * @return 硬件版本
     */
    public EHardwareVersion selectEHardwareVersionById(Long id);

    /**
     * 查询硬件版本列表
     *
     * @param etHardwareVersion 硬件版本
     * @return 硬件版本集合
     */
    public List<EHardwareVersion> selectEHardwareVersionList(EHardwareVersion etHardwareVersion);

    /**
     * 新增硬件版本
     *
     * @param etHardwareVersion 硬件版本
     * @return 结果
     */
    public int insertEHardwareVersion(EHardwareVersion etHardwareVersion);

    /**
     * 修改硬件版本
     *
     * @param etHardwareVersion 硬件版本
     * @return 结果
     */
    public int updateEHardwareVersion(EHardwareVersion etHardwareVersion);

    /**
     * 删除硬件版本
     *
     * @param id 硬件版本主键
     * @return 结果
     */
    public int deleteEHardwareVersionById(Long id);

    /**
     * 批量删除硬件版本
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEHardwareVersionByIds(Long[] ids);
}
