package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.room.ERoom;
import com.ruoyi.system.domain.room.ERoomVO;
import com.ruoyi.system.domain.room.ERoomQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 房间Mapper接口
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface ERoomMapper
{
    /**
     * 查询房间
     *
     * @param roomId 房间主键
     * @return 房间
     */
    public ERoomVO selectERoomByRoomId(Long roomId);

    /**
     * 查询房间列表
     *
     * @param query 房间
     * @return 房间集合
     */
    public List<ERoomVO> selectERoomList(@Param("query")ERoomQuery query);

    /**
     * 新增房间
     *
     * @param eRoom 房间
     * @return 结果
     */
    public int insertERoom(ERoom eRoom);

    /**
     * 修改房间
     *
     * @param eRoom 房间
     * @return 结果
     */
    public int updateERoom(@Param("data") ERoom eRoom);

    /**
     * 删除房间
     *
     * @param roomId 房间主键
     * @return 结果
     */
    public int deleteERoomByRoomId(Long roomId);

    /**
     * 批量删除房间
     *
     * @param roomIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteERoomByRoomIds(Long[] roomIds);

    /**
     * 根据店铺id查询房间列表
     *
     * @param storeId 店铺id
     * @return 房间集合
     */
    List<ERoomVO> selectERoomListByStoreId(Long storeId);
}
