package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.store.EStore;
import com.ruoyi.system.domain.store.EStoreVO;
import com.ruoyi.system.domain.store.EStoreQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 店铺Mapper接口
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface EStoreMapper
{
    /**
     * 查询店铺
     *
     * @param storeId 店铺主键
     * @return 店铺
     */
    public EStoreVO selectEStoreByStoreId(Long storeId);

    /**
     * 查询店铺列表
     *
     * @param query 店铺
     * @return 店铺集合
     */
    public List<EStoreVO> selectEStoreList(@Param("query")EStoreQuery query);

    /**
     * 新增店铺
     *
     * @param eStore 店铺
     * @return 结果
     */
    public int insertEStore(EStore eStore);

    /**
     * 修改店铺
     *
     * @param eStore 店铺
     * @return 结果
     */
    public int updateEStore(@Param("data") EStore eStore);

    /**
     * 删除店铺
     *
     * @param storeId 店铺主键
     * @return 结果
     */
    public int deleteEStoreByStoreId(Long storeId);

    /**
     * 批量删除店铺
     *
     * @param storeIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEStoreByStoreIds(Long[] storeIds);

    /**
     * 根据定位获取城市店铺列表
     */
    List<EStoreVO> selectEStoreByCityId(Long cityId);
}
