package com.ruoyi.system.mapper;

import com.ruoyi.system.domain.triplog.ETripLog;

import java.util.List;

/**
 * 行程记录Mapper接口
 *
 * @author 邱贞招
 * @date 2024-05-13
 */
public interface ETripLogMapper
{
    /**
     * 查询行程记录
     *
     * @param tripId 行程记录主键
     * @return 行程记录
     */
    public ETripLog selectEtTripLogByTripId(Long tripId);

    /**
     * 查询行程记录列表
     *
     * @param etTripLog 行程记录
     * @return 行程记录集合
     */
    public List<ETripLog> selectEtTripLogList(ETripLog etTripLog);

    /**
     * 新增行程记录
     *
     * @param etTripLog 行程记录
     * @return 结果
     */
    public int insertEtTripLog(ETripLog etTripLog);

    /**
     * 修改行程记录
     *
     * @param etTripLog 行程记录
     * @return 结果
     */
    public int updateEtTripLog(ETripLog etTripLog);

    /**
     * 删除行程记录
     *
     * @param tripId 行程记录主键
     * @return 结果
     */
    public int deleteEtTripLogByTripId(Long tripId);

    /**
     * 批量删除行程记录
     *
     * @param tripIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEtTripLogByTripIds(Long[] tripIds);
}
