package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.address.EUserAddress;

/**
 * 用户地址Mapper接口
 *
 * @author qzz
 * @date 2024-11-09
 */
public interface EUserAddressMapper
{
    /**
     * 查询用户地址
     *
     * @param id 用户地址主键
     * @return 用户地址
     */
    public EUserAddress selectEUserAddressById(Long id);

    /**
     * 查询用户地址列表
     *
     * @param eUserAddress 用户地址
     * @return 用户地址集合
     */
    public List<EUserAddress> selectEUserAddressList(EUserAddress eUserAddress);

    /**
     * 新增用户地址
     *
     * @param eUserAddress 用户地址
     * @return 结果
     */
    public int insertEUserAddress(EUserAddress eUserAddress);

    /**
     * 修改用户地址
     *
     * @param eUserAddress 用户地址
     * @return 结果
     */
    public int updateEUserAddress(EUserAddress eUserAddress);

    /**
     * 删除用户地址
     *
     * @param id 用户地址主键
     * @return 结果
     */
    public int deleteEUserAddressById(Long id);

    /**
     * 批量删除用户地址
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEUserAddressByIds(Long[] ids);
}
