package com.ruoyi.system.mapper;

import com.ruoyi.system.domain.userWithdraw.EUserWithdraw;

import java.util.List;

/**
 * 用户提现渠道Mapper接口
 *
 * @author qzz
 * @date 2024-10-21
 */
public interface EUserWithdrawMapper
{
    /**
     * 查询用户提现渠道
     *
     * @param userChannelId 用户提现渠道主键
     * @return 用户提现渠道
     */
    public EUserWithdraw selectRlUserWithdrawByUserChannelId(Long userChannelId);

    /**
     * 查询用户提现渠道列表
     *
     * @param rlUserWithdraw 用户提现渠道
     * @return 用户提现渠道集合
     */
    public List<EUserWithdraw> selectRlUserWithdrawList(EUserWithdraw rlUserWithdraw);

    /**
     * 新增用户提现渠道
     *
     * @param rlUserWithdraw 用户提现渠道
     * @return 结果
     */
    public int insertRlUserWithdraw(EUserWithdraw rlUserWithdraw);

    /**
     * 修改用户提现渠道
     *
     * @param rlUserWithdraw 用户提现渠道
     * @return 结果
     */
    public int updateRlUserWithdraw(EUserWithdraw rlUserWithdraw);

    /**
     * 删除用户提现渠道
     *
     * @param userChannelId 用户提现渠道主键
     * @return 结果
     */
    public int deleteRlUserWithdrawByUserChannelId(Long userChannelId);

    /**
     * 批量删除用户提现渠道
     *
     * @param userChannelIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRlUserWithdrawByUserChannelIds(Long[] userChannelIds);

    /**
     * 根据userId查询用户提现渠道列表
     *
     * @param userId 用户id
     * @return 用户提现渠道集合
     */
    List<EUserWithdraw> selectRlUserWithdrawListByUserId(Long userId);
}
