package com.ruoyi.system.model.mapper;

import com.ruoyi.system.model.domain.EModel;
import com.ruoyi.system.model.domain.EModelQuery;
import com.ruoyi.system.model.domain.EModelVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 车辆型号Mapper接口
 *
 * @author 邱贞招
 * @date 2024-05-13
 */
public interface EModelMapper
{
    /**
     * 查询型号列表
     *
     * @param modelId 型号列表主键
     * @return 型号列表
     */
    public EModelVO selectSmModelByModelId(Long modelId);

    /**
     * 查询型号列表列表
     *
     * @param smModel 型号列表
     * @return 型号列表集合
     */
    public List<EModelVO> selectSmModelList(EModelQuery smModel);

    /**
     * 新增型号列表
     *
     * @param smModel 型号列表
     * @return 结果
     */
    public int insertSmModel(EModel smModel);

    /**
     * 修改型号列表
     *
     * @param smModel 型号列表
     * @return 结果
     */
    public int updateSmModel(EModel smModel);

    /**
     * 删除型号列表
     *
     * @param modelId 型号列表主键
     * @return 结果
     */
    public int deleteSmModelByModelId(Long modelId);

    /**
     * 批量删除型号列表
     *
     * @param modelIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSmModelByModelIds(Long[] modelIds);

    /**
     * 条件查询数量
     * @param dto 查询条件
     * @return 结果
     */
    Integer selectCount(EModelQuery dto);

    int logicDeleteByIds(@Param("modelIds") List<Long> modelIds);

    /**
     * 查询一个
     */
    EModelVO selectOne(EModelQuery query);
}
