package com.ruoyi.system.order.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.system.domain.EFunction;
import com.ruoyi.system.domain.accessory.EAccessoryVO;
import com.ruoyi.system.domain.orderOper.EOrderOper;
import com.ruoyi.system.domain.rule.EFeeRuleVO;
import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

@Data
public class EOrderVO extends EOrder {

    /** 用户名*/
    private String userName;

    /** 姓名*/
    private String realName;

    /** 租车周期描述 */
    private String rentalPeriodText;

    /** 店铺地址 */
    private String storeAddress;

    /** 代理商 */
    private String agentName;

    @Excel(name = "配件列表")
    private List<EAccessoryVO> accessorys;

    @Excel(name = "功能列表")
    private List<EFunction> functionList;

    /** 图片 */
    @Excel(name = "图片")
    private String picture;

    /** 套餐 */
    private EFeeRuleVO rule;

    /** 操作履历 */
    private List<EOrderOper> orderOpers;

    /** 可退款金额 */
    private BigDecimal refundableTotalAmount;

    private BigDecimal refundableDispatchFee;  // 调度费

    private BigDecimal refundableDeliveryFee;  // 配送费

    private BigDecimal refundableLeaseFee;  // 租赁费（骑行费）

    private BigDecimal refundableDeposit;  // 押金

}
