package com.ruoyi.system.order.service.impl;

import com.ruoyi.common.core.domain.BaseValidator;
import com.ruoyi.common.core.domain.ValidateResult;
import com.ruoyi.system.order.domain.EOrderBO;
import com.ruoyi.system.order.service.IEOrderValidator;
import org.springframework.stereotype.Service;

@Service
public class IEOrderValidatorImpl extends BaseValidator implements IEOrderValidator {

    @Override
    public ValidateResult preAddOrder(EOrderBO bo) {
        if (bo == null) {
            return error("数据不能为空");
        }

        // todo  用户还有未支付的订单
        //        营业时间
        //        用户还有进行中的订单
        //        房间还有进行中的订单
        //        价格已发生变化
        //        价格未配置
        //        小时未配置
//        RechargeDTO dto = bo.getParams();
//
//        // 门店
//        StoreVo store = bo.getStore();
//        if (store != null) {
//            LocalTime now = LocalTime.now();
//            if (!storeValidator.isBusinessTime(store, now)) {
//                return error(String.format("请在营业时间内使用该设备!%s - %s%s",
//                        store.getBusinessTimeStart(),
//                        store.getBusinessTimeEnd().isAfter(store.getBusinessTimeStart()) ? "" : "次日",
//                        store.getBusinessTimeEnd()));
//            }
//        }
//
//        // 用户
//        SmUserVO user = bo.getUser();
//        // 检查用户是否有未支付的智能分时段订单
//        if (this.hasUnpaidSmartTimingOrder(user.getUserId())) {
//            return error("您有未支付的订单，请先支付后继续");
//        }
//        // 检查用户是否有正在使用中的智能订单
//        if (this.hasUsingSmartOrder(user.getUserId())) {
//            return error("您有正在使用中的智能订单，请结束后继续");
//        }
//
//        // 检查设备是否符合条件
//        DeviceVO device = bo.getDevice();
//        if (device == null || device.getDeleted()) {
//            return error("当前设备不存在");
//        }
//        if (StringUtils.isEmpty(device.getMac())) {
//            return error("当前设备Mac为空，无法充值");
//        }
//        if (device.getLimitRechargeTime() != null && LocalDateTime.now().isBefore(device.getLimitRechargeTime())) {
//            return error("当前设备被限制充值：" + device.getLimitRechargeReason());
//        }
//
//        // 判断设备是否有正在使用中的订单
//        TransactionBillQuery query = new TransactionBillQuery();
//        query.setDeviceId(device.getDeviceId());
//        List<TransactionBillVO> usingBill = transactionBillService.selectUsingBill(query);
//        if (CollectionUtils.isNotEmptyElement(usingBill)) {
//            return error("该设备有正在使用中的订单，暂时无法下单");
//        }
//
//        // 商户检查
//        SmUserVO mch = bo.getMch();
//        if (!userValidator.isUsage(device.getUserId())) {
//            return error("当前设备商户不存在或不可用，无法充值，请确认商户账号是否正常");
//        }
//        // 若商户开启了获取用户手机号，则判断用户是否有手机号
//        if (mch.getShowBillMobile() != null && mch.getShowBillMobile() && StringUtils.isBlank(user.getPhonenumber())) {
//            return error("当前用户未绑定手机号，无法下单");
//        }
//
//        // 套餐检查
//        SuitVO suit = bo.getSuit();
//        if (suit == null) {
//            return error("当前设备套餐不存在");
//        }
//        List<Long> suitDeviceIds = suit.getDeviceList().stream().map(DeviceVO::getDeviceId).collect(Collectors.toList());   // 套餐应用的设备列表
//        if (!suitDeviceIds.contains(device.getDeviceId())) {
//            return error("当前设备没有该套餐");
//        }
//        if (suit.getPrice() == null) {
//            return error("当前套餐未配置价格，请联系商户处理");
//        }
//        if (suit.getPrice().compareTo(dto.getSuitPrice()) != 0) {
//            return error("当前套餐价格已发生变化，请重新下单");
//        }
//        if (SuitFeeMode.SMART.getMode().equals(suit.getFeeMode())) {
//            if (suit.getDeposit().compareTo(dto.getSuitDeposit()) != 0) {
//                return error("当前套餐押金已发生变化，请重新下单");
//            }
//        }
//        if (!suit.getFeeMode().equals(dto.getSuitFeeMode())) {
//            return error("当前套餐套餐发生变化，请重新下单");
//        }
//        if (!suit.getFeeType().equals(dto.getSuitFeeType())) {
//            return error("当前套餐收费类型发生变化，请重新下单");
//        }
//        if (SuitFeeType.singleList().contains(suit.getFeeType())) {
//            // 一次性收费需要配置时间/度数
//            if (suit.getValue() == null) {
//                return error("当前套餐未配置时间/电量，请联系商户处理");
//            }
//            if (SuitFeeType.needConfigTimeUnit().contains(suit.getFeeType()) && suit.getTimeUnit() == null) {
//                return error("当前套餐未配置时长单位，请联系商户处理");
//            }
//        }
//        if (!Objects.equals(suit.getValue(), dto.getSuitTime())) {
//            return error("当前套餐时间/度数已发生变化，请重新下单");
//        }
//        if (!Objects.equals(suit.getTimeUnit(), dto.getSuitTimeUnit())) {
//            return error("当前套餐时间已发生变化，请重新下单");
//        }
//        if (!CollectionUtils.equals(suit.getGearAmount(), dto.getSuitGearAmount())) {
//            return error("套餐收费方式已发生变化，请重新下单");
//        }
//        if (!CollectionUtils.equals(suit.getGearTime(), dto.getSuitGearTime())) {
//            return error("套餐收费方式已发生变化，请重新下单");
//        }

//        if (SuitFeeMode.SMART.getMode().equals(suit.getFeeMode())) {
//            if (device.getExpireTime() != null && device.getExpireTime().isAfter(LocalDateTime.now())) {
//                return error("当前设备还有剩余时长，无法选择智能收费方式下单");
//            }
//            if (DeviceOnlineStatus.ONLINE.getStatus().equals(device.getOnlineStatus())
//                    && device.getSurplusEle() != null
//                    && device.getSurplusEle().compareTo(BigDecimal.ZERO) > 0) {
//                return error("当前设备还有剩余电量，无法选择智能收费方式下单");
//            }
//        }
        return success();
    }
}
