package com.ruoyi.system.service;

import com.ruoyi.system.domain.accessory.EAccessory;
import com.ruoyi.system.domain.accessory.EAccessoryVO;

import java.util.List;

/**
 * 配件Service接口
 *
 * @author qzz
 * @date 2024-09-19
 */
public interface IEAccessoryService
{
    /**
     * 查询配件
     *
     * @param accessoryId 配件主键
     * @return 配件
     */
    public EAccessory selectRlAccessoryByAccessoryId(Long accessoryId);

    /**
     * 查询配件列表
     *
     * @param rlAccessory 配件
     * @return 配件集合
     */
    public List<EAccessory> selectRlAccessoryList(EAccessory rlAccessory);

    /**
     * 根据车型id查询配件列表
     *
     * @param modelId 车型id
     * @return 配件集合
     */
    public List<EAccessoryVO> selectRlAccessoryListByModelId(Long modelId);

    /**
     * 新增配件
     *
     * @param rlAccessory 配件
     * @return 结果
     */
    public int insertRlAccessory(EAccessory rlAccessory);

    /**
     * 修改配件
     *
     * @param rlAccessory 配件
     * @return 结果
     */
    public int updateRlAccessory(EAccessory rlAccessory);

    /**
     * 批量删除配件
     *
     * @param accessoryIds 需要删除的配件主键集合
     * @return 结果
     */
    public int deleteRlAccessoryByAccessoryIds(Long[] accessoryIds);

    /**
     * 删除配件信息
     *
     * @param accessoryId 配件主键
     * @return 结果
     */
    public int deleteRlAccessoryByAccessoryId(Long accessoryId);

    /**
     * 查询车辆配件
     *
     * @param deviceId 车辆id
     * @return 车辆配件
     */
    public List<EAccessoryVO> selectRlDeviceAccessoryByModelId(Long deviceId);

}
