package com.ruoyi.system.service;

import java.util.List;
import com.ruoyi.system.domain.rule.EFeeRule;
import com.ruoyi.system.domain.rule.EFeeRuleVO;
import com.ruoyi.system.domain.rule.EFeeRuleQuery;

/**
 * 收费模板Service接口
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface IEFeeRuleService
{
    /**
     * 查询收费模板
     *
     * @param ruleId 收费模板主键
     * @return 收费模板
     */
    public EFeeRuleVO selectEFeeRuleByRuleId(Long ruleId);

    /**
     * 查询收费模板列表
     *
     * @param eFeeRule 收费模板
     * @return 收费模板集合
     */
    public List<EFeeRuleVO> selectEFeeRuleList(EFeeRuleQuery eFeeRule);

    /**
     * 新增收费模板
     *
     * @param eFeeRule 收费模板
     * @return 结果
     */
    public int insertEFeeRule(EFeeRule eFeeRule);

    /**
     * 修改收费模板
     *
     * @param eFeeRule 收费模板
     * @return 结果
     */
    public int updateEFeeRule(EFeeRule eFeeRule);

    /**
     * 批量删除收费模板
     *
     * @param ruleIds 需要删除的收费模板主键集合
     * @return 结果
     */
    public int deleteEFeeRuleByRuleIds(Long[] ruleIds);

    /**
     * 删除收费模板信息
     *
     * @param ruleId 收费模板主键
     * @return 结果
     */
    public int deleteEFeeRuleByRuleId(Long ruleId);

    /**
     * 根据房间id获取套餐
     */
    List<EFeeRuleVO> selectEFeeRuleListByRoomId(Long roomId);
}
