package com.ruoyi.system.service;

import com.ruoyi.system.domain.EFunction;

import java.util.List;

/**
 * 功能Service接口
 *
 * @author ruoyi
 * @date 2024-09-26
 */
public interface IEFunctionService
{
    /**
     * 查询功能
     *
     * @param functionId 功能主键
     * @return 功能
     */
    public EFunction selectRlFunctionByFunctionId(Long functionId);

    /**
     * 查询功能列表
     *
     * @param rlFunction 功能
     * @return 功能集合
     */
    public List<EFunction> selectRlFunctionList(EFunction rlFunction);

    /**
     * 新增功能
     *
     * @param rlFunction 功能
     * @return 结果
     */
    public int insertRlFunction(EFunction rlFunction);

    /**
     * 修改功能
     *
     * @param rlFunction 功能
     * @return 结果
     */
    public int updateRlFunction(EFunction rlFunction);

    /**
     * 批量删除功能
     *
     * @param functionIds 需要删除的功能主键集合
     * @return 结果
     */
    public int deleteRlFunctionByFunctionIds(Long[] functionIds);

    /**
     * 删除功能信息
     *
     * @param functionId 功能主键
     * @return 结果
     */
    public int deleteRlFunctionByFunctionId(Long functionId);

    /**
     * 根据车型id获取功能
     */
    List<EFunction> selectRlFunctionByModelId(Long modelId);
}
