package com.ruoyi.system.service;

import com.ruoyi.system.domain.EMsgLog;

import java.util.List;

/**
 * 短信日志Service接口
 *
 * @author qiuzhenzhen
 * @date 2024-07-24
 */
public interface IEMsgLogService
{
    /**
     * 查询短信日志
     *
     * @param id 短信日志主键
     * @return 短信日志
     */
    public EMsgLog selectEtMsgLogById(Long id);

    /**
     * 查询短信日志列表
     *
     * @param eMsgLog 短信日志
     * @return 短信日志集合
     */
    public List<EMsgLog> selectEtMsgLogList(EMsgLog eMsgLog);

    /**
     * 新增短信日志
     *
     * @param eMsgLog 短信日志
     * @return 结果
     */
    public int insertEtMsgLog(EMsgLog eMsgLog);

    /**
     * 修改短信日志
     *
     * @param eMsgLog 短信日志
     * @return 结果
     */
    public int updateEtMsgLog(EMsgLog eMsgLog);

    /**
     * 批量删除短信日志
     *
     * @param ids 需要删除的短信日志主键集合
     * @return 结果
     */
    public int deleteEtMsgLogByIds(Long[] ids);

    /**
     * 删除短信日志信息
     *
     * @param id 短信日志主键
     * @return 结果
     */
    public int deleteEtMsgLogById(Long id);
}
