package com.ruoyi.system.service;

import com.ruoyi.system.domain.area.EOperatingArea;
import com.ruoyi.system.domain.area.EOperatingAreaVO;

import java.util.List;

/**
 * 运营区Service接口
 *
 * @author qzz
 * @date 2024-09-18
 */
public interface IEOperatingAreaService
{
    /**
     * 查询运营区
     *
     * @param areaId 运营区主键
     * @return 运营区
     */
    public EOperatingArea selectRlOperatingAreaByAreaId(Long areaId);

    /**
     * 根据代理商id查询运营区
     *
     * @param agentId 运营区主键
     * @return 运营区
     */
    public EOperatingAreaVO selectRlOperatingAreaByAgentId(Long agentId);

    /**
     * 查询运营区列表
     *
     * @param rlOperatingArea 运营区
     * @return 运营区集合
     */
    public List<EOperatingArea> selectRlOperatingAreaList(EOperatingArea rlOperatingArea);

    /**
     * 新增运营区
     *
     * @param rlOperatingArea 运营区
     * @return 结果
     */
    public int insertRlOperatingArea(EOperatingArea rlOperatingArea);

    /**
     * 修改运营区
     *
     * @param rlOperatingArea 运营区
     * @return 结果
     */
    public int updateRlOperatingArea(EOperatingArea rlOperatingArea);

    /**
     * 批量删除运营区
     *
     * @param areaIds 需要删除的运营区主键集合
     * @return 结果
     */
    public int deleteRlOperatingAreaByAreaIds(Long[] areaIds);

    /**
     * 删除运营区信息
     *
     * @param areaId 运营区主键
     * @return 结果
     */
    public int deleteRlOperatingAreaByAreaId(Long areaId);

    /**
     * 根据代理商id查询运营区id
     *
     * @param agentId 代理商id
     * @return 结果
     */
    Long selectAreaIdByAgentId(Long agentId);
}
