package com.ruoyi.system.service;

import java.util.List;
import com.ruoyi.system.domain.room.ERoom;
import com.ruoyi.system.domain.room.ERoomVO;
import com.ruoyi.system.domain.room.ERoomQuery;

/**
 * 房间Service接口 店长
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface IERoomService
{
    /**
     * 查询房间
     *
     * @param roomId 房间主键
     * @return 房间
     */
    public ERoomVO selectERoomByRoomId(Long roomId);

    /**
     * 查询房间列表
     *
     * @param eRoom 房间
     * @return 房间集合
     */
    public List<ERoomVO> selectERoomList(ERoomQuery eRoom);

    /**
     * 根据店铺id查询房间列表
     *
     * @param storeId 店铺id
     * @return 房间集合
     */
    public List<ERoomVO> selectERoomListByStoreId(Long storeId);

    /**
     * 新增房间
     *
     * @param eRoom 房间
     * @return 结果
     */
    public int insertERoom(ERoom eRoom);

    /**
     * 修改房间
     *
     * @param eRoom 房间
     * @return 结果
     */
    public int updateERoom(ERoom eRoom);

    /**
     * 批量删除房间
     *
     * @param roomIds 需要删除的房间主键集合
     * @return 结果
     */
    public int deleteERoomByRoomIds(Long[] roomIds);

    /**
     * 删除房间信息
     *
     * @param roomId 房间主键
     * @return 结果
     */
    public int deleteERoomByRoomId(Long roomId);

    /**
     * 开门
     * @param roomId 房间主键
     * @return String
     */
    boolean openGate(Long roomId);
}
