package com.ruoyi.system.service.impl;

import com.ruoyi.system.domain.ECommandLog;
import com.ruoyi.system.mapper.ECommandLogMapper;
import com.ruoyi.system.service.IECommandLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 命令日志Service业务层处理
 *
 * @author 邱贞招
 * @date 2024-07-06
 */
@Service
public class ECommandLogServiceImpl implements IECommandLogService
{
    @Autowired
    private ECommandLogMapper eCommandLogMapper;

    /**
     * 查询命令日志
     *
     * @param id 命令日志主键
     * @return 命令日志
     */
    @Override
    public ECommandLog selectEtCommandLogById(Long id)
    {
        return eCommandLogMapper.selectEtCommandLogById(id);
    }

    /**
     * 查询命令日志列表
     *
     * @param eCommandLog 命令日志
     * @return 命令日志
     */
    @Override
    public List<ECommandLog> selectEtCommandLogList(ECommandLog eCommandLog)
    {
        return eCommandLogMapper.selectEtCommandLogList(eCommandLog);
    }

    /**
     * 新增命令日志
     *
     * @param eCommandLog 命令日志
     * @return 结果
     */
    @Override
    public int insertEtCommandLog(ECommandLog eCommandLog)
    {
        return eCommandLogMapper.insertEtCommandLog(eCommandLog);
    }

    /**
     * 修改命令日志
     *
     * @param eCommandLog 命令日志
     * @return 结果
     */
    @Override
    public int updateEtCommandLog(ECommandLog eCommandLog)
    {
        return eCommandLogMapper.updateEtCommandLog(eCommandLog);
    }

    /**
     * 批量删除命令日志
     *
     * @param ids 需要删除的命令日志主键
     * @return 结果
     */
    @Override
    public int deleteEtCommandLogByIds(Long[] ids)
    {
        return eCommandLogMapper.deleteEtCommandLogByIds(ids);
    }

    /**
     * 删除命令日志信息
     *
     * @param id 命令日志主键
     * @return 结果
     */
    @Override
    public int deleteEtCommandLogById(Long id)
    {
        return eCommandLogMapper.deleteEtCommandLogById(id);
    }
}
