//package com.ruoyi.system.service.impl;
//
//import cn.hutool.core.util.ObjectUtil;
//import cn.hutool.core.util.StrUtil;
//import com.alibaba.fastjson2.JSON;
//import com.alibaba.fastjson2.JSONObject;
//import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
//import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
//import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
//import com.ruoyi.common.annotation.DataScope;
//import com.ruoyi.common.constant.*;
//import com.ruoyi.common.core.redis.RedisCache;
//import com.ruoyi.common.exception.ServiceException;
//import com.ruoyi.common.utils.CommonUtil;
//import com.ruoyi.common.utils.DateUtils;
//import com.ruoyi.common.utils.StringUtils;
//import com.ruoyi.common.utils.http.HttpUtils;
//import com.ruoyi.common.utils.onenet.*;
//import com.ruoyi.system.domain.ECommandLog;
//import com.ruoyi.system.domain.EOnlineLog;
//import com.ruoyi.system.domain.device.EDevice;
//import com.ruoyi.system.domain.device.EDeviceQuery;
//import com.ruoyi.system.domain.device.EDeviceVO;
//import com.ruoyi.system.domain.order.EOrder;
//import com.ruoyi.system.domain.order.EOrderQuery;
//import com.ruoyi.system.domain.order.EOrderVO;
//import com.ruoyi.system.mapper.ECommandLogMapper;
//import com.ruoyi.system.mapper.EDeviceMapper;
//import com.ruoyi.system.model.service.IEModelService;
//import com.ruoyi.system.service.*;
//import lombok.SneakyThrows;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.stereotype.Service;
//import org.springframework.transaction.annotation.Transactional;
//import org.springframework.transaction.support.TransactionTemplate;
//
//import javax.annotation.Resource;
//import java.math.BigDecimal;
//import java.math.RoundingMode;
//import java.util.Date;
//import java.util.List;
//import java.util.concurrent.ScheduledExecutorService;
//import java.util.concurrent.TimeUnit;
//
///**
// * 设备Service业务层处理
// *
// * @author 邱贞招
// * @date 2024-04-05
// */
//@Slf4j
//@Service
//public class EDeviceServiceImpl extends ServiceImpl<EDeviceMapper, EDevice> implements IEDeviceService
//{
//    @Resource
//    private EDeviceMapper deviceMapper;
//
//    @Autowired
//    private TransactionTemplate transactionTemplate;
//
//    @Autowired
//    private IEAccessoryService accessoryService;
//
//    @Autowired
//    private IEOrderService orderService;
//
//    @Autowired
//    private IEOrderOperService orderOperService;
//
//    @Resource
//    private IETripLogService tripLogService;
//
//    @Resource
//    private IEModelService modelService;
//
//    @Autowired
//    private ScheduledExecutorService scheduledExecutorService;
//
//    @Resource
//    private ECommandLogMapper eCommandLogMapper;
//
//    @Autowired
//    private IEOnlineLogService eOnlineLogService;
//
//    @Autowired
//    private RedisCache redisCache;
//
//    @Value(value = "${iot.iotUrl}")
//    private String iotUrl;
//
//    @Value(value = "${iot.productId}")
//    private String productId;
//
//    @Value(value = "${iot.timeout}")
//    private String timeout;
//
//    @Value(value = "${iot.deviceUrl}")
//    private String deviceUrl;
//
//    /**
//     * 查询设备
//     *
//     * @param deviceId 设备主键
//     * @return 设备
//     */
//    @Override
//    public EDevice selectEDeviceByDeviceId(Long deviceId)
//    {
//        EDevice device = deviceMapper.selectEDeviceByDeviceId(deviceId);
//        return device;
//    }
//
//    /**
//     * 根据mac查询车辆实时信息
//     *
//     * @param mac 设备mac
//     * @return 设备
//     */
//    @Override
//    public EDevice selectEDeviceByMac(String mac) {
//        return deviceMapper.selectEDeviceByMac(mac);
//    }
//
//    /**
//     * 根据sn号查询车辆实时信息  真实金额  实际
//     *
//     * @param sn 设备sn
//     * @return 设备
//     */
//    @SneakyThrows
//    @Override
//    public EDevice selectEDeviceBySn(String sn) {
//        return deviceMapper.selectEDeviceBySn(sn);
//    }
//
//    /**
//     * 查询设备列表
//     *
//     * @param asDevice 设备
//     * @return 设备
//     */
//    @Override
//    public List<EDevice> selectEDeviceList(EDevice asDevice)
//    {
//        return deviceMapper.selectEDeviceList(asDevice);
//    }
//
//    /**
//     * 根据sn号查询车辆实时信息  真实金额  实际
//     *
//     * @param sn 设备sn
//     * @return 设备
//     */
//    @Override
//    public EDeviceVO getLatestLocationBySn(String sn) {
//        EDeviceVO rlDevice = deviceMapper.selectEDeviceBySn(sn);
//        if (ObjectUtil.isNull(rlDevice)) {
//            throw new ServiceException("设备不存在："+ sn);
//        }
//        String msg = redisCache.getCacheObject(CacheConstants.CACHE_DEVICE_KEY + rlDevice.getSn());
//        if(StrUtil.isNotBlank(msg)){
//            log.info("【根据sn号查询车辆实时信息】-========redis缓存中的数据：" + msg);
//            LogEntry logEntry = JSONObject.parseObject(msg, LogEntry.class);
//            log.info("【根据sn号查询车辆实时信息】============logEntry转换后的对象: logEntry---【{}】" , JSON.toJSONString(logEntry));
//            LogEntry.LocationValue value = logEntry.getValue();
//            // 坐标转换  WGS84 转 GCJ02
//            double[] doubles = CommonUtil.coordinateConvert(value.getLon(),value.getLat());
//            BigDecimal lon = new BigDecimal(doubles[1]).setScale(8, RoundingMode.HALF_UP);
//            BigDecimal lat = new BigDecimal(doubles[0]).setScale(8, RoundingMode.HALF_UP);
//            rlDevice.setLongitude(lon.toString());
//            rlDevice.setLatitude(lat.toString());
//        }
//        return rlDevice;
//    }
//
//    /**
//     * 查询设备列表
//     *
//     * @param asDevice 设备 隔离
//     * @return 设备
//     */
//    @Override
//    @DataScope(merchantAlias = "m", userAlias = "u")
//    public List<EDevice> selectEDeviceListWithIsolate(EDeviceQuery asDevice)
//    {
//        if(ServiceConstants.VEHICLE_STATUS_NOT_BAND.equals(asDevice.getStatus())){
//            asDevice.setStatus(null);
//        }
//        List<EDevice> asDevices = deviceMapper.selectEDeviceListWithIsolate(asDevice);
////        for (EDevice asDevice1:asDevices){
////            Long areaId = asDevice1.getAreaId();
////            if (ObjectUtil.isNotNull(areaId) && areaId!=0){
////                EtOperatingArea etOperatingArea = etOperatingAreaService.selectEtOperatingAreaByAreaId(areaId);
////                asDevice1.setAreaName(etOperatingArea.getAreaName());
////            }
////            Long modelId = asDevice1.getModelId();
////            if (ObjectUtil.isNotNull(modelId)){
////                EtModel model  = etModelService.selectEtModelByModelId(modelId);
////                if(ObjectUtil.isNotNull(model)){
////                    asDevice1.setModel(model.getModel());
////                }
////            }
////            String status = asDevice1.getStatus();
////            if(ObjectUtil.isNotNull(status)){
////                String typeName = sysDictDataService.selectDictLabel("as_device_status", status);
////                asDevice1.setStatusStr(typeName);
////                if(status.equals(ServiceConstants.VEHICLE_STATUS_NOT_BAND) && ObjectUtil.isNotNull(asDevice1.getAreaId())){
////                    asDevice1.setStatus(ServiceConstants.VEHICLE_STATUS_NOT_LISTING);
////                    int i = deviceMapper.updateAsDevice(asDevice1);
////                }
////            }
////            if(ObjectUtil.isNull(asDevice1.getAreaId())){
////                asDevice1.setStatus(ServiceConstants.VEHICLE_STATUS_NOT_BAND);
////                int i = deviceMapper.updateAsDevice(asDevice1);
////            }
////            if(ObjectUtil.isNotNull(areaId) && areaId!=0){
////                SysDept sysDept = wxPayService.getDeptObjByAreaId(areaId);
////                //https://dianche.chuantewulian.cn?sn=https://dche.ccttiot.com?sn=3000900
////                asDevice1.setQrText(sysDept.getDomain()+"?sn="+asDevice1.getSn());
////                asDevice1.setDeptName(sysDept.getDeptName());
////            }else{
////                asDevice1.setQrText("");
////            }
////        }
//        return asDevices;
//    }
//
//    /**
//     * 新增设备
//     *
//     * @param asDevice 设备
//     * @return 结果
//     */
//    @Override
//    public int insertEDevice(EDevice asDevice)
//    {
//        asDevice.setCreateTime(DateUtils.getNowDate());
//        return deviceMapper.insertEDevice(asDevice);
//    }
//
//    /**
//     * 修改设备
//     *
//     * @param asDevice 设备
//     * @return 结果
//     */
//    @Override
//    public int updateEDevice(EDevice asDevice)
//    {
//        asDevice.setUpdateTime(DateUtils.getNowDate());
//        int i = deviceMapper.updateEDevice(asDevice);
//        //预约后开始计费
//
//        return i;
//    }
//
//    /**
//     * 修改设备
//     *
//     * @param asDevice 设备
//     * @return 结果
//     */
//    @Override
//    public int updateEDevice2(EDevice asDevice)
//    {
//        asDevice.setUpdateTime(DateUtils.getNowDate());
////        if(asDevice.getAreaId() == null){
////            asDevice.setStatus(ServiceConstants.VEHICLE_STATUS_NOT_BAND);
////            asDevice.setOnlineStatus(ServiceConstants.VEHICLE_STATUS_OFFLINE);
////            asDevice.setLockStatus(ServiceConstants.LOCK_STATUS_CLOSE);
////        }
//        return deviceMapper.updateEDevice2(asDevice);
//    }
//
//    /**
//     * 根据SN修改设备
//     *
//     * @param asDevice 设备
//     * @return 结果
//     */
//    @Override
//    public int updateEDeviceBySn(EDeviceQuery asDevice)
//    {
//        asDevice.setUpdateTime(DateUtils.getNowDate());
//        return deviceMapper.updateEDeviceBySn(asDevice);
//    }
//
//    /**
//     * 取消默认
//     *
//     * @param userId 用户id
//     * @param sn sn
//     * @return 结果
//     */
//    @Override
//    public int cancelDefault(Long userId, String sn)
//    {
//        return deviceMapper.cancelDefault(userId,sn);
//    }
//
//    /**
//     * 批量删除设备
//     *
//     * @param deviceIds 需要删除的设备主键
//     * @return 结果
//     */
//    @Override
//    public int deleteEDeviceByDeviceIds(Long[] deviceIds)
//    {
//        return deviceMapper.deleteEDeviceByDeviceIds(deviceIds);
//    }
////
////    /**
////     * 一键上线
////     *
////     * @param deviceIds 需要一键上线的设备主键集合
////     * @return 结果
////     */
////    @Override
////    public int oneClickOnline(Long[] deviceIds)
////    {
////        for (Long deviceId:deviceIds) {
////            AsDevice device = deviceMapper.selectAsDeviceByDeviceId(deviceId);
////            if(ObjectUtil.isNull(device)){
////                throw new ServiceException("车辆【"+deviceId+"】不存在");
////            }
////            if(!device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_IN_OFFLINE)){
////                throw new ServiceException("车辆【"+device.getSn()+"】非下线状态，请重新选择！");
////            }
////        }
////        return deviceMapper.oneClickOnline(deviceIds);
////    }
////
////    /**
////     * 一键出仓
////     *
////     * @param deviceIds 需要一键出仓的设备主键集合
////     * @return 结果
////     */
////    @Override
////    public int oneClickListing(Long[] deviceIds)
////    {
////        for (Long deviceId:deviceIds) {
////            AsDevice device = deviceMapper.selectAsDeviceByDeviceId(deviceId);
////            if(ObjectUtil.isNull(device)){
////                throw new ServiceException("车辆【"+deviceId+"】不存在");
////            }
////            if(!device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_NOT_LISTING)){
////                throw new ServiceException("车辆【"+device.getSn()+"】非仓库中状态，请重新选择！");
////            }
////        }
////        return deviceMapper.oneClickOnline(deviceIds);
////    }
////
////    /**
////     * 一键下线
////     *
////     * @param deviceIds 需要一键下线的设备主键集合
////     * @return 结果
////     */
////    @Override
////    public int oneClickOffline(Long[] deviceIds)
////    {
////        for (Long deviceId:deviceIds) {
////            AsDevice device = deviceMapper.selectAsDeviceByDeviceId(deviceId);
////            if(ObjectUtil.isNull(device)){
////                throw new ServiceException("车辆【"+deviceId+"】不存在");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_IN_APPOINTMENT)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘预约中’状态不能下线");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_IN_USING)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘使用中’状态不能下线");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_TEMPORARILY_LOCK)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘临时停车’状态不能下线");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_NOT_LISTING)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘未上架’状态不能下线");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_ABANDON)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘废弃’状态不能下线");
////            }
////        }
////        return deviceMapper.oneClickOffline(deviceIds);
////    }
////
////    /**
////     * 一键入仓
////     *
////     * @param deviceIds 需要一键入仓的设备主键集合
////     * @return 结果
////     */
////    @Override
////    public int oneClickWarehousing(Long[] deviceIds)
////    {
////        for (Long deviceId:deviceIds) {
////            AsDevice device = deviceMapper.selectAsDeviceByDeviceId(deviceId);
////            if(ObjectUtil.isNull(device)){
////                throw new ServiceException("车辆【"+deviceId+"】不存在");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_IN_APPOINTMENT)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘预约中’状态不能入仓");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_IN_USING)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘使用中’状态不能入仓");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_TEMPORARILY_LOCK)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘临时停车’状态不能入仓");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_NOT_LISTING)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘仓库中’状态不能入仓");
////            }
////            if(device.getStatus().equals(ServiceConstants.VEHICLE_STATUS_ABANDON)){
////                throw new ServiceException("车辆【"+device.getSn()+"】为‘废弃’状态不能入仓");
////            }
////        }
////        return deviceMapper.oneClickWarehousing(deviceIds);
////    }
//
//    /**
//     * 更新设备
//     * 1. 发送更新版本
//     * 2. 判断是否在线
//     *
//     * @param deviceIds 需要更新设备的设备主键集合
//     * @return 结果
//     */
//    @Override
//    public int refreshDevice(Long[] deviceIds)
//    {
//        for (Long deviceId:deviceIds) {
//            EDevice device = deviceMapper.selectEDeviceByDeviceId(deviceId);
//            //设备是否在线
//            if(isOnline(device.getSn())){
//                log.info("设备【"+device.getSn()+"】在线");
//            }else{
//                log.info("设备【"+device.getSn()+"】不在线");
//            }
//            if(updateVersion(device.getSn())){
//                log.info("设备【"+device.getSn()+"】更新版本成功");
//            }else{
//                log.info("设备【"+device.getSn()+"】更新版本失败");
//            }
//        }
//        return 1;
//    }
//
//    /**
//     * 管理员开锁
//     */
//    @SneakyThrows
//    @Override
//    public Boolean unlocking(String sn,String userName) {
//        EDevice asDevice = deviceMapper.selectEDeviceBySn(sn);
//        if(ObjectUtil.isNull(asDevice)){
//            throw new ServiceException("设备不存在");
//        }
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            EDevice updateDevice = new EDevice();
//            updateDevice.setDeviceId(asDevice.getDeviceId());
//            /** 2.发送命令*/
//            sendCommand(asDevice.getMac(), token,IotConstants.COMMAND_OPEN+IotConstants.COMMAND_FREQUENCY_20,"管理员开锁",null,userName);
//            updateDevice.setIsAdminUnlocking("1");
//            if(!asDevice.getStatus().equals(ServiceConstants.VEHICLE_STATUS_NOT_LISTING)){
//                updateDevice.setStatus(ServiceConstants.VEHICLE_STATUS_SCHEDULING);
//            }
//            updateDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_OPEN);
//            int i = deviceMapper.updateEDevice(updateDevice);
//            if(i>0){
//                log.info("管理员开锁，更新设备状态成功");
//            }
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("管理员开锁失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 管理员开锁
//     */
//    @SneakyThrows
//    @Override
//    public Boolean unlockingByMac(String mac,String userName) {
//        EDevice asDevice = deviceMapper.selectEDeviceByMac(mac);
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(mac, token,IotConstants.COMMAND_OPEN+IotConstants.COMMAND_FREQUENCY_20,"管理员开锁",null,userName);
//            asDevice.setIsAdminUnlocking("1");
//            if(!asDevice.getStatus().equals(ServiceConstants.VEHICLE_STATUS_NOT_LISTING)){
//                asDevice.setStatus(ServiceConstants.VEHICLE_STATUS_SCHEDULING);
//            }
//            asDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_OPEN);
//            int i = deviceMapper.updateEDevice(asDevice);
//            if(i>0){
//                log.info("管理员开锁，更新设备状态成功");
//            }
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("管理员开锁失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 车辆上线
//     */
//    @SneakyThrows
//    @Override
//    public Boolean online(String sn) {
//        EDevice asDevice = deviceMapper.selectEDeviceBySn(sn);
//        asDevice.setStatus(ServiceConstants.VEHICLE_STATUS_NORMAL);
//        int device = deviceMapper.updateEDevice(asDevice);
//        if(device==0){
//            log.info("车辆上线状态失败");
//            return Boolean.FALSE;
//        }
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 车辆下线
//     */
//    @SneakyThrows
//    @Override
//    public Boolean offline(String sn,String status) {
//        EDevice asDevice = deviceMapper.selectEDeviceBySn(sn);
//        if(ServiceConstants.VEHICLE_STATUS_IN_USING.equals(asDevice.getStatus())){
//            throw new ServiceException("车辆使用中，不能下线");
//        }
//        if(ServiceConstants.VEHICLE_STATUS_TEMPORARILY_LOCK.equals(asDevice.getStatus())){
//            throw new ServiceException("车辆临时停车中，不能下线");
//        }
//        asDevice.setStatus(status);
//        int device = deviceMapper.updateEDevice(asDevice);
//        if(device==0){
//            log.info("车辆下线状态失败");
//            return Boolean.FALSE;
//        }
//        return Boolean.TRUE;
//    }
//
//
//    /**
//     * 根据车辆型号查询车辆数量
//     */
//    @Override
//    public Integer selectCountByModelId(Long modelId) {
//        QueryWrapper<EDevice> wrapper = new QueryWrapper<>();
//        wrapper.eq("model_id", modelId);
//        Integer integer = deviceMapper.selectCount(wrapper);
//        return integer;
//    }
//
//    @Transactional
//    @Override
//    /** 发送命令*/
//    public void sendCommand(String mac, String token,String command,String type,String orderNo,String userName) {
//        String param = "device_name=" + mac + "&product_id=" + productId +"&timeout=" + timeout;
//        String sendUrl = iotUrl+ IotConstants.ADDS_COMMAND + "?"+param;
//        String result = HttpUtils.sendPostWithToken(sendUrl, command, token);
//        log.info("【"+type+"】===>IOT请求调用结果:【{}】",result);
//        JSONObject paramsObj = JSON.parseObject(result);
//        String code = paramsObj.getString("code");
//
//        if ("10500".equals(code)) { // 超时
//            log.info("第一次请求超时，进行第二次请求...");
//            result = HttpUtils.sendPostWithToken(sendUrl, command, token);
//            log.info("【" + type + "】===>IOT第二次请求调用结果:【{}】", result);
//            paramsObj = JSON.parseObject(result);
//            code = paramsObj.getString("code");
//        }
//
//        asynchronousSaveLog(sendUrl,command,mac,result,type,orderNo,userName);
//        //记录命令
//        if (!HttpStatus.IOT_SUCCESS.equals(code))
//        {
//            // 异步更新在线状态
//            asynchronousUpdateOnlineStatus(mac);
//            throw new ServiceException(code+"-----"+ IotUtil.formatMsg(code));
//        }
//    }
//
//    private void asynchronousUpdateOnlineStatus(String mac) {
//        EDevice device = deviceMapper.selectEDeviceByMac(mac);
//        //异步更新在线状态
//        scheduledExecutorService.schedule(() -> {
//            if(device.getOnlineStatus().equals(ServiceConstants.VEHICLE_STATUS_ONLINE)){
//                log.info("【接收onenet推送】异步更新在线状态"+JSON.toJSONString(device));
//                device.setOnlineStatus(ServiceConstants.VEHICLE_STATUS_OFFLINE);
//                int i = deviceMapper.updateEDevice(device);
//                if(i>0){
//                    log.info("【接收onenet推送】异步保存在线状态成功");
//                }
//            }
//            EOnlineLog etOnlineLog = new EOnlineLog();
//            etOnlineLog.setMac(device.getMac());
//            etOnlineLog.setSn(device.getSn());
//            etOnlineLog.setOnlineStatus(ServiceConstants.VEHICLE_STATUS_OFFLINE);
//            etOnlineLog.setLongitude(device.getLongitude());
//            etOnlineLog.setLatitude(device.getLatitude());
//            etOnlineLog.setCreateTime(DateUtils.getNowDate());
//            int i1 = eOnlineLogService.insertEtOnlineLog(etOnlineLog);
//            if(i1>0){
//                log.info("【接收onenet推送】异步保存在线日志成功");
//            }
//        }, 0, TimeUnit.SECONDS);
//    }
//
//    /* 异步保存发送命令日志*/
//    private void asynchronousSaveLog(String url,String command,String mac,String result,String type,String orderNo,String userName) {
//        //异步保存发送命令日志
//        scheduledExecutorService.schedule(() -> {
//            ECommandLog etCommandLog = new ECommandLog();
//            etCommandLog.setUrl(url);
//            etCommandLog.setCommand(command);
//            etCommandLog.setType(type);
//            etCommandLog.setMac(mac);
//            EDevice device = deviceMapper.selectEDeviceByMac(mac);
//            etCommandLog.setSn(device.getSn());
//            etCommandLog.setResult(result);
//            etCommandLog.setLongitude(device.getLongitude());
//            etCommandLog.setLatitude(device.getLatitude());
//            etCommandLog.setCreateTime(DateUtils.getNowDate());
//            JSONObject paramsObj = JSON.parseObject(result);
//            String code = paramsObj.getString("code");
//            etCommandLog.setCallStatus(code);
//            etCommandLog.setOrderNo(orderNo);
//            etCommandLog.setCreateBy(userName);
//            int i = eCommandLogMapper.insertEtCommandLog(etCommandLog);
//            if(i>0){
//                log.info("【发送命令】异步保存发送命令日志");
//            }
//        }, 0, TimeUnit.SECONDS);
//    }
//
//    @Override
//    /** 发送命令*/
//    public ResponseVo sendCommandWithResp(String mac, String token,String command,String type,String orderNo) {
//        String param = "device_name=" + mac + "&product_id=" + productId +"&timeout=" + timeout;
//        String sendUrl = iotUrl+ IotConstants.ADDS_COMMAND + "?"+param;
//        String result = HttpUtils.sendPostWithToken(sendUrl, command, token);
//        log.info("【"+type+"】===>IOT请求调用结果:【{}】",result);
//        ResponseVo responseVo = JSON.parseObject(result, ResponseVo.class);
//
//        if (responseVo.getCode() == 10500) { // 超时
//            log.info("第一次请求超时，进行第二次请求...");
//            result = HttpUtils.sendPostWithToken(sendUrl, command, token);
//            log.info("【" + type + "】===>IOT第二次请求调用结果:【{}】", result);
//            responseVo = JSON.parseObject(result, ResponseVo.class);
//        }
//
//        if(responseVo.getCode() != 0){
//            asynchronousUpdateOnlineStatus(mac);
//        }
//        asynchronousSaveLog(sendUrl,command,mac,result,type,orderNo,null);
//        return JSON.parseObject(result,ResponseVo.class);
//    }
//
//    /** 查询数据点*/
//    @Override
//    public DataPointRes historyDatapoints(String mac, String token) {
//        String param = "device_name=" + mac + "&product_id=" + productId +"&timeout=" + timeout;
//        String sendUrl = iotUrl+ IotConstants.ADDS_CURRENT_DATAPOINTS + "?"+param;
//        String result = HttpUtils.sendGetWithToken(sendUrl, null, token);
//        log.info("【查询数据点】===>IOT请求调用结果:【{}】",result);
//        return JSON.parseObject(result,DataPointRes.class);
//    }
//
//    /**
//     * 响铃寻车
//     * @param sn
//     * @return
//     */
//    @SneakyThrows
//    @Override
//    public Boolean ring(String sn) {
//        EDevice asDevice = deviceMapper.selectEDeviceBySn(sn);
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(asDevice.getMac(), token,IotConstants.COMMAND_PLAY1,"响铃寻车",null,null);
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("响铃寻车失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 开坐垫锁
//     * @param sn
//     * @return
//     */
//    @SneakyThrows
//    @Override
//    public Boolean seatCushionLock(String sn) {
//        EDevice eDevice = deviceMapper.selectEDeviceBySn(sn);
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(eDevice.getMac(), token,IotConstants.COMMAND_HPEN,"开坐垫锁",null,null);
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("开坐垫锁失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 重启设备
//     * @param sn
//     * @return
//     */
//    @SneakyThrows
//    @Override
//    public Boolean reboot(String sn) {
//        EDevice asDevice = deviceMapper.selectEDeviceBySn(sn);
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(asDevice.getMac(), token,IotConstants.COMMAND_PLAY1,"重启设备",null,null);
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("重启设备失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 重启设备
//     * @param mac
//     * @return
//     */
//    @SneakyThrows
//    @Override
//    public Boolean rebootByMac(String mac) {
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(mac, token,IotConstants.COMMAND_REBOOT,"重启设备",null,null);
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("重启设备失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 响铃寻车
//     * @param mac
//     * @return
//     */
//    @SneakyThrows
//    @Override
//    public Boolean ringByMac(String mac) {
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(mac, token,IotConstants.COMMAND_PLAY1,"响铃寻车",null,null);
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("响铃寻车失败");
//        return Boolean.TRUE;
//    }
//
//
//    /**
//     * 坐垫锁用mac
//     * @param mac
//     * @return
//     */
//    @SneakyThrows
//    @Override
//    public Boolean seatCushionLockByMac(String mac) {
//        /** 1.获取token*/
//        String token = Token.getToken();
//        Boolean execute = transactionTemplate.execute(e -> {
//            /** 2.发送命令*/
//            sendCommand(mac, token,IotConstants.COMMAND_HPEN,"开坐垫锁",null,null);
//            return Boolean.TRUE;
//        });
//        if(!execute)throw new ServiceException("开坐垫锁失败");
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 临时锁车
//     * @param orderNo
//     * @return
//     */
//    @Transactional
//    @SneakyThrows
//    @Override
//    public Boolean lock(String sn,String orderNo,String isBluetooth,String lon,String lat) {
//        EOrderVO order = orderService.selectRlOrderByOrderNo(orderNo);
//        if(StrUtil.isBlank(sn)) {
//            sn = order.getSn();
//        }
//        EDeviceVO asDevice = deviceMapper.selectEDeviceBySn(sn);
//        /** 1.获取token*/
//        String token = Token.getToken();
//        if(!"true".equals(isBluetooth)){
//            /** 2.发送命令*/
//            sendCommand(asDevice.getMac(), token,IotConstants.COMMAND_LLOSE+IotConstants.COMMAND_FREQUENCY_3600,"临时锁车",orderNo,order.getUserName());
//        }else{
//            asDevice.setLongitude(lon);
//            asDevice.setLatitude(lat);
//            asDevice.setLastTime(DateUtils.getNowDate());
//        }
//        asDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_CLOSE);
//        if(StrUtil.isNotBlank(orderNo)){//有订单号，则是用户临时锁车
//            /**  改变车辆状态：4-临时锁车 */
//            asDevice.setStatus(ServiceConstants.VEHICLE_STATUS_TEMPORARILY_LOCK);//临时锁车
//            /** 5.记录行程*/
//            int tripLog = tripLogService.tripLog(orderNo, sn,ServiceConstants.TRIP_LOG_TYPE_TEMPORARILY_LOCK);
//            if(tripLog==0){
//                log.info("【临时锁车】记录行程失败");
//                throw new ServiceException("【临时锁车】记录行程失败");
//            }
//        }
//        int device = deviceMapper.updateEDevice(asDevice);
//        if(device==0){
//            log.info("【临时解锁】改变车辆状态失败");
//            throw new ServiceException("【临时锁车】改变车辆状态失败");
//        }
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 管理员锁车
//     * @param sn
//     * @return
//     */
//    @Transactional
//    @SneakyThrows
//    @Override
//    public Boolean adminLock(String sn,String userName) {
//        if(StrUtil.isBlank(sn))throw new ServiceException("sn不能为空");
//        EDevice eDevice = deviceMapper.selectEDeviceBySn(sn);
//        /** 2.发送命令*/
//        sendCommand(eDevice.getMac(), Token.getToken(),IotConstants.COMMAND_CLOSE+IotConstants.COMMAND_FREQUENCY_3600,"管理员锁车",null,userName);
//        eDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_CLOSE);
//        int device = deviceMapper.updateEDevice(eDevice);
//        if(device==0){
//            log.info("【临时解锁】改变车辆状态失败");
//            throw new ServiceException("【临时锁车】改变车辆状态失败");
//        }
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 管理员锁车
//     * @param mac
//     * @return
//     */
//    @Transactional
//    @SneakyThrows
//    @Override
//    public Boolean adminLockByMac(String mac,String userName) {
//        if(StrUtil.isBlank(mac))throw new ServiceException("mac不能为空");
//        EDevice asDevice = deviceMapper.selectEDeviceByMac(mac);
//        /** 2.发送命令*/
//        sendCommand(asDevice.getMac(), Token.getToken(),IotConstants.COMMAND_CLOSE+IotConstants.COMMAND_FREQUENCY_3600,"管理员锁车",null,userName);
//        asDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_CLOSE);
//        int device = deviceMapper.updateEDevice(asDevice);
//        if(device==0){
//            log.info("【临时解锁】改变车辆状态失败");
//            throw new ServiceException("【临时锁车】改变车辆状态失败");
//        }
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 临时解锁
//     */
//    @Transactional
//    @SneakyThrows
//    @Override
//    public Boolean unlock(String sn, String orderNo,String isBluetooth,String lon,String lat) {
//        EOrderVO order = orderService.selectRlOrderByOrderNo(orderNo);
//        if(order==null)throw new ServiceException("订单不存在");
//        if(StrUtil.isBlank(sn)) {
//            sn = order.getSn();
//        }
//        EDevice asDevice = deviceMapper.selectEDeviceBySn(sn);
//        EDevice updateDevice = new EDevice();
//        updateDevice.setDeviceId(asDevice.getDeviceId());
//        /** 1.获取token*/
//        String token = Token.getToken();
//        String finalSn = sn;
//        if(!"true".equals(isBluetooth)){
//            /** 2.发送命令*/
//            sendCommand(asDevice.getMac(), token,IotConstants.COMMAND_OPEN+IotConstants.COMMAND_FREQUENCY_5,"临时解锁",orderNo,order.getUserName());
//        }else{
//            updateDevice.setLongitude(lon);
//            updateDevice.setLatitude(lat);
//            updateDevice.setLastTime(DateUtils.getNowDate());
//        }
//        if(StrUtil.isNotBlank(orderNo)){//有订单号，则是用户骑行中解锁
//            /**  改变车辆状态：3-骑行中 */
//            updateDevice.setStatus(ServiceConstants.VEHICLE_STATUS_IN_USING);//骑行中
//            updateDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_OPEN);
//            /** 5.记录行程*/
//            int tripLog = tripLogService.tripLog(orderNo, finalSn,ServiceConstants.TRIP_LOG_TYPE_TEMPORARILY_UNLOCK);
//            if(tripLog==0){
//                log.info("【临时解锁】记录行程失败");
//                throw new ServiceException("【临时解锁】记录行程失败");
//            }
//        }else{
//            /**  改变车辆锁状态：1-开  */
//            updateDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_OPEN);
//        }
//        int device = deviceMapper.updateEDevice(updateDevice);
//        if(device==0){
//            log.info("【临时解锁】改变车辆状态失败");
//            throw new ServiceException("【临时解锁】改变车辆状态失败");
//        }
//        return Boolean.TRUE;
//    }
//
//    /**
//     * 还车
//     */
//    @SneakyThrows
//    @Override
//    @Transactional
//    public Boolean returnVehicle(EOrderQuery orderQuery) {
//        String orderNo = orderQuery.getOrderNo();
//        if(StrUtil.isNotBlank(orderNo)){
//            EOrderVO order = orderService.selectRlOrderByOrderNo(orderNo);
//            if(ObjectUtil.isNull(order)){
//                throw new ServiceException("订单不存在");
//            }
//            if(!ServiceConstants.ORDER_STATUS_IN_USE.equals(order.getStatus())){
//                throw new ServiceException("该订单状态非使用中");
//            }
//            EOrder updateOrder = new EOrder();
//            /** 1. 记录还车时间*/
//            updateOrder.setOrderId(order.getOrderId());
//            updateOrder.setReturnType(orderQuery.getReturnType());
//            updateOrder.setReturnTime(DateUtils.getNowDate());
//            updateOrder.setStatus(ServiceConstants.ORDER_STATUS_TO_BE_AUDITED);// 还车后订单状态变成待审核，只有商户确认才算完成
//            String token = Token.getToken();
//
//            EDevice device = deviceMapper.selectEDeviceBySn(order.getSn());
//            EDevice updateDevice = new EDevice();
//            updateDevice.setDeviceId(device.getDeviceId());
//            if(ServiceConstants.RETURN_TYPE_NORMAL.equals(orderQuery.getReturnType())){
//                /** 2.1 车辆远程关锁*/
//                ResponseVo responseVo = sendCommandWithResp(device.getMac(), token, IotConstants.COMMAND_CLOSE + IotConstants.COMMAND_FREQUENCY_3600, "还车关锁",orderNo);
//                if(responseVo.getCode()!=0){
//                    log.info("【还车关锁】远程关锁失败");
//                    throw new ServiceException("远程关锁失败");
//                }
//            }else{
//                ResponseVo responseVo = sendCommandWithResp(device.getMac(), token, IotConstants.COMMAND_CLOSE + IotConstants.COMMAND_FREQUENCY_3600, "辅助还车关锁",orderNo);
//                if(responseVo.getCode()!=0){
//                    log.info("【还车关锁】远程关锁失败");
//                }
//            }
//            /** 4. 更新车辆状态*/
//            updateDevice.setStatus(ServiceConstants.VEHICLE_STATUS_NORMAL);
//            updateDevice.setPowerStatus(ServiceConstants.LOCK_STATUS_CLOSE);
//            int deviceUpdate = deviceMapper.updateEDevice(updateDevice);
//            if(deviceUpdate==0){
//                log.info("【还车关锁】更新车辆状态失败");
//                throw new ServiceException("【还车关锁】更新车辆状态失败");
//            }
//            /** 5.记录行程*/
//            int tripLog = tripLogService.tripLog(order.getOrderNo(),device.getSn(),ServiceConstants.TRIP_LOG_TYPE_RETRUN_LOCK);
//            if(tripLog==0){
//                log.info("【还车关锁】记录行程失败");
//                throw new ServiceException("【还车关锁】记录行程失败");
//            }
//            /** 6.计算逾期费用 */
//            BigDecimal overdueFee= BigDecimal.ZERO;
//            if(ObjectUtil.isNull(order.getExpiryTime())){
//                throw new ServiceException("订单没有到期时间");
//            }
//            if (order.getExpiryTime().before(DateUtils.getNowDate())) {
//                overdueFee = computeOverdueFee(order, updateOrder);
//            }
//            updateOrder.setOverdueFee(overdueFee);
//            int i = orderService.updateRlOrder(updateOrder);
//            if(i==0){
//                throw new ServiceException("更新订单状态失败");
//            }
//            /** 7. 记录订单履历*/
//            if(!orderOperService.recordOrderHistory(orderNo,ServiceConstants.ORDER_OPERATION_RETURN_END,
//                    order.getStatus(),updateOrder.getStatus(),order.getPayFee(),order.getPayFee(),order.getUserId(),order.getPhone(),"已还车")){
//                throw new ServiceException("【记录订单履历失败】");
//            }
//            log.info("还车成功");
//            return Boolean.TRUE;
//        }else{
//            throw new ServiceException("订单号不能为空");
//        }
//    }
//
//    /** 计算逾期费用 */
//    public BigDecimal computeOverdueFee(EOrderVO order, EOrder updateOrder) {
//        String outUnit = order.getOutUnit();
//        BigDecimal outPrice = order.getOutPrice();
//        // 计算逾期的时间单位
//        Date nowDate = DateUtils.getNowDate();
//        int overdueUnits = 0;
//
//        // 根据不同单位计算逾期的具体时间差
//        switch (outUnit) {
//            case "minutes":
//                overdueUnits = DateUtils.timeDifferenceInMinutes(nowDate, order.getExpiryTime()); // 计算分钟差
//                break;
//            case "hours":
//                overdueUnits = DateUtils.timeDifferenceInHours(nowDate, order.getExpiryTime()); // 计算小时差
//                break;
//            case "day":
//                overdueUnits = DateUtils.differentDaysByMillisecond(nowDate, order.getExpiryTime()); // 计算天数差
//                break;
//            default:
//                throw new ServiceException("【还车】未知的逾期单位：" + outUnit);
//        }
//        // 计算逾期费用 = 逾期的单位数量 * 每单位价格
//        BigDecimal overdueFee = outPrice.multiply(new BigDecimal(overdueUnits));
//        updateOrder.setOverdueFee(overdueFee);
//        return overdueFee;
//    }
//
//    /** 获取到该代理商下所有的车辆数 */
//    @Override
//    public Integer getTatalDeviceCount(Long merchantId,String status,String[] statusList) {
//        return deviceMapper.getTatalDeviceCount(merchantId,status,statusList);
//    }
//
//    /**
//     * 更新位置信息
//     */
//    @Override
//    public int updateLocation(EDevice device) {
//        UpdateWrapper<EDevice> wrapper = new UpdateWrapper<>();
//        wrapper.eq("sn",device.getSn())
//                .set("longitude",device.getLongitude())
//                .set("latitude",device.getLatitude())
//                .set("last_time",device.getLastTime());
//        return deviceMapper.update(null,wrapper);
//    }
//
//    /**
//     * 判断是否在线
//     */
//    @SneakyThrows
//    @Override
//    public boolean isOnline(String sn) {
//        EDevice device = deviceMapper.selectEDeviceBySn(sn);
//        ResponseVo responseVo = sendCommandWithResp(device.getMac(), Token.getToken(), "111", "是否在线",null);
//        if(responseVo.getCode() == 0){
//            return true;
//        }
//        asynchronousUpdateOnlineStatus(device.getMac());
//        return false;
//    }
//
//    /**
//     * 检查SN是否唯一
//     */
//    @Override
//    public boolean checkSNUnique(EDevice asDevice) {
//        Long deviceId = StringUtils.isNull(asDevice.getDeviceId()) ? -1L : asDevice.getDeviceId();
//        EDevice info = deviceMapper.checkSNUnique(asDevice.getSn());
//        if (StringUtils.isNotNull(info) && info.getDeviceId().longValue() != deviceId.longValue())
//        {
//            return UserConstants.NOT_UNIQUE;
//        }
//        return UserConstants.UNIQUE;
//    }
//
//    /**
//     * 检查SN是否唯一
//     */
//    @Override
//    public boolean checkMACUnique(EDevice asDevice) {
//        Long deviceId = StringUtils.isNull(asDevice.getDeviceId()) ? -1L : asDevice.getDeviceId();
//        EDevice info = deviceMapper.checkMACUnique(asDevice.getMac());
//        if (StringUtils.isNotNull(info) && info.getDeviceId().longValue() != deviceId.longValue())
//        {
//            return UserConstants.NOT_UNIQUE;
//        }
//        return UserConstants.UNIQUE;
//    }
//
//    /**
//     * 根据mac号判断是否有绑定过
//     */
//    @Override
//    public boolean isBandByMac(String mac) {
//        EDevice info = deviceMapper.checkMACUnique(mac);
//        if (StringUtils.isNull(info))
//        {
//            return UserConstants.NOT_UNIQUE;
//        }
//        return UserConstants.UNIQUE;
//    }
//
//    /**
//     * 查询版本并更新
//     */
//    @Override
//    @SneakyThrows
//    public boolean updateVersion(String sn) {
//        EDevice device = deviceMapper.selectEDeviceBySn(sn);
//        if(device!=null){
//            String version = device.getVersion();
//            if(StrUtil.isBlank(version)){
//                String token = Token.getToken();
//                DataPointRes datapoints = historyDatapoints(deviceMapper.selectEDeviceBySn(sn).getMac(), token);
//                if(datapoints.getCode() == 0){
//                    Data data = datapoints.getData();
//                    List<Datastream> datastreams = data.getDevices();
//                    for (Datastream datastream: datastreams) {
//                        List<Datapoint> datapointList = datastream.getDatastreams();
//                        if(ObjectUtil.isNotNull(datapointList)){
//                            for (Datapoint datapoint:datapointList) {
//                                if(datapoint.getId().equals(IotConstants.ONENET_VER)){
//                                    Integer value = (Integer)datapoint.getValue();
//                                    log.info("【查询数据点】===>获取到版本值：【{}】", value);
//                                    if(value != null){
//                                        EDevice device1 = new EDevice();
//                                        device1.setVersion(value.toString());
//                                        device1.setSn(sn);
//                                        if(deviceMapper.updateEDeviceBySn(device1) > 0){
//                                            log.info("【查询数据点】===>更新版本成功");
//                                            return true;
//                                        }else{
//                                            log.info("【查询数据点】===>更新版本失败");
//                                        }
//                                    }
//                                }
//                            }
//                        }
//                    }
//                }
//            }
//        }
//        return false;
//    }
//
//
//    /**
//     * sn和mac号绑定
//     * 注册onenet设备
//     */
//    @SneakyThrows
//    @Override
//    public int bandSn(EDevice eDevice) {
//        EDevice device = deviceMapper.selectEDeviceByMac(eDevice.getMac());
//        if(StringUtils.isNotNull(device)){
//            device.setSn(eDevice.getSn());
//            device.setHardwareVersionId(eDevice.getHardwareVersionId());
//            int i = deviceMapper.updateEDeviceBySn(device);
//            if(i>0){
//                log.info("【sn和mac号绑定】===>mac【{}】已经绑定过:更新sn【{}】成功",device.getMac(),device.getSn());
//            }
//        }else{
//            // 调用onenet接口
//            CreateDeviceVo createDeviceVo = new CreateDeviceVo();
//            createDeviceVo.setDevice_name(eDevice.getMac());
//            createDeviceVo.setProduct_id(productId);
//            String result = HttpUtils.sendPostWithToken(deviceUrl,JSON.toJSONString(createDeviceVo), Token.getToken());
//            log.info("【sn和mac号绑定】===>IOT请求调用结果:【{}】",result);
//            JSONObject paramsObj = JSON.parseObject(result);
//            String code = paramsObj.getString("code");
//            //记录命令
//            if (!HttpStatus.IOT_SUCCESS.equals(code))
//            {
//                throw new ServiceException(code+"-----"+ paramsObj.getString("msg"));
//            }
//            try{
//                int insert = deviceMapper.insert(eDevice);
//                if(insert==0){
//                    throw new ServiceException("该SN已经存在，请勿重复绑定！");
//                }
//            }catch (Exception e){
//                log.error("该SN已经存在,{}",e.getMessage());
//                throw new ServiceException("该SN已经存在，请勿重复绑定！");
//            }
//        }
//        return 1;
//    }
//
//    /**
//     * 根据mac修改sn
//     */
//    @SneakyThrows
//    @Override
//    public int updateSn(EDevice asDevice) {
//        EDevice device = new EDevice();
//        device.setSn(asDevice.getSn());
//        device.setHardwareVersionId(asDevice.getHardwareVersionId());
//        device.setMac(asDevice.getMac());
//        int i = deviceMapper.updateEDeviceByMac(device);
//        if(i>0){
//            log.info("【sn和mac号绑定】===>mac【{}】已经绑定过:更新sn【{}】成功",device.getMac(),device.getSn());
//        }
//        return 1;
//    }
//
//}
