package com.ruoyi.system.service.impl;

import com.ruoyi.system.domain.EFunction;
import com.ruoyi.system.mapper.EFunctionMapper;
import com.ruoyi.system.service.IEFunctionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 功能Service业务层处理
 *
 * @author ruoyi
 * @date 2024-09-26
 */
@Service
public class EFunctionServiceImpl implements IEFunctionService
{
    @Autowired
    private EFunctionMapper rlFunctionMapper;

    /**
     * 查询功能
     *
     * @param functionId 功能主键
     * @return 功能
     */
    @Override
    public EFunction selectRlFunctionByFunctionId(Long functionId)
    {
        return rlFunctionMapper.selectRlFunctionByFunctionId(functionId);
    }

    /**
     * 查询功能列表
     *
     * @param rlFunction 功能
     * @return 功能
     */
    @Override
    public List<EFunction> selectRlFunctionList(EFunction rlFunction)
    {
        return rlFunctionMapper.selectRlFunctionList(rlFunction);
    }

    /**
     * 新增功能
     *
     * @param rlFunction 功能
     * @return 结果
     */
    @Override
    public int insertRlFunction(EFunction rlFunction)
    {
        return rlFunctionMapper.insertRlFunction(rlFunction);
    }

    /**
     * 修改功能
     *
     * @param rlFunction 功能
     * @return 结果
     */
    @Override
    public int updateRlFunction(EFunction rlFunction)
    {
        return rlFunctionMapper.updateRlFunction(rlFunction);
    }

    /**
     * 批量删除功能
     *
     * @param functionIds 需要删除的功能主键
     * @return 结果
     */
    @Override
    public int deleteRlFunctionByFunctionIds(Long[] functionIds)
    {
        return rlFunctionMapper.deleteRlFunctionByFunctionIds(functionIds);
    }

    /**
     * 删除功能信息
     *
     * @param functionId 功能主键
     * @return 结果
     */
    @Override
    public int deleteRlFunctionByFunctionId(Long functionId)
    {
        return rlFunctionMapper.deleteRlFunctionByFunctionId(functionId);
    }

    /**
     * 根据车型id获取功能
     */
    @Override
    public List<EFunction> selectRlFunctionByModelId(Long modelId) {
        return rlFunctionMapper.selectRlFunctionByModelId(modelId);
    }
}
