package com.ruoyi.system.service.impl;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.system.domain.EHardwareVersion;
import com.ruoyi.system.mapper.EHardwareVersionMapper;
import com.ruoyi.system.mapper.EHardwareVersionMapper;
import com.ruoyi.system.service.IEHardwareVersionService;
import com.ruoyi.system.service.IEHardwareVersionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 硬件版本Service业务层处理
 *
 * @author qiuzhenzhao
 * @date 2024-07-22
 */
@Service
public class EHardwareVersionServiceImpl implements IEHardwareVersionService
{
    @Resource
    private EHardwareVersionMapper eHardwareVersionMapper;

    /**
     * 查询硬件版本
     *
     * @param id 硬件版本主键
     * @return 硬件版本
     */
    @Override
    public EHardwareVersion selectEHardwareVersionById(Long id)
    {
        return eHardwareVersionMapper.selectEHardwareVersionById(id);
    }

    /**
     * 查询硬件版本列表
     *
     * @param EHardwareVersion 硬件版本
     * @return 硬件版本
     */
    @Override
    public List<EHardwareVersion> selectEHardwareVersionList(EHardwareVersion EHardwareVersion)
    {
        return eHardwareVersionMapper.selectEHardwareVersionList(EHardwareVersion);
    }

    /**
     * 新增硬件版本
     *
     * @param EHardwareVersion 硬件版本
     * @return 结果
     */
    @Override
    public int insertEHardwareVersion(EHardwareVersion EHardwareVersion)
    {
        EHardwareVersion.setCreateTime(DateUtils.getNowDate());
        return eHardwareVersionMapper.insertEHardwareVersion(EHardwareVersion);
    }

    /**
     * 修改硬件版本
     *
     * @param EHardwareVersion 硬件版本
     * @return 结果
     */
    @Override
    public int updateEHardwareVersion(EHardwareVersion EHardwareVersion)
    {
        return eHardwareVersionMapper.updateEHardwareVersion(EHardwareVersion);
    }

    /**
     * 批量删除硬件版本
     *
     * @param ids 需要删除的硬件版本主键
     * @return 结果
     */
    @Override
    public int deleteEHardwareVersionByIds(Long[] ids)
    {
        return eHardwareVersionMapper.deleteEHardwareVersionByIds(ids);
    }

    /**
     * 删除硬件版本信息
     *
     * @param id 硬件版本主键
     * @return 结果
     */
    @Override
    public int deleteEHardwareVersionById(Long id)
    {
        return eHardwareVersionMapper.deleteEHardwareVersionById(id);
    }
}
