package com.ruoyi.system.service.impl;

import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.system.mapper.EUserAddressMapper;
import com.ruoyi.system.domain.address.EUserAddress;
import com.ruoyi.system.service.IEUserAddressService;

/**
 * 用户地址Service业务层处理
 *
 * @author qzz
 * @date 2024-11-09
 */
@Service
public class EUserAddressServiceImpl implements IEUserAddressService
{
    @Autowired
    private EUserAddressMapper eUserAddressMapper;

    /**
     * 查询用户地址
     *
     * @param id 用户地址主键
     * @return 用户地址
     */
    @Override
    public EUserAddress selectEUserAddressById(Long id)
    {
        return eUserAddressMapper.selectEUserAddressById(id);
    }

    /**
     * 查询用户地址列表
     *
     * @param eUserAddress 用户地址
     * @return 用户地址
     */
    @Override
    public List<EUserAddress> selectEUserAddressList(EUserAddress eUserAddress)
    {
        return eUserAddressMapper.selectEUserAddressList(eUserAddress);
    }

    /**
     * 新增用户地址
     *
     * @param eUserAddress 用户地址
     * @return 结果
     */
    @Override
    public int insertEUserAddress(EUserAddress eUserAddress)
    {
        eUserAddress.setCreateTime(DateUtils.getNowDate());
        return eUserAddressMapper.insertEUserAddress(eUserAddress);
    }

    /**
     * 修改用户地址
     *
     * @param eUserAddress 用户地址
     * @return 结果
     */
    @Override
    public int updateEUserAddress(EUserAddress eUserAddress)
    {
        eUserAddress.setUpdateTime(DateUtils.getNowDate());
        return eUserAddressMapper.updateEUserAddress(eUserAddress);
    }

    /**
     * 批量删除用户地址
     *
     * @param ids 需要删除的用户地址主键
     * @return 结果
     */
    @Override
    public int deleteEUserAddressByIds(Long[] ids)
    {
        return eUserAddressMapper.deleteEUserAddressByIds(ids);
    }

    /**
     * 删除用户地址信息
     *
     * @param id 用户地址主键
     * @return 结果
     */
    @Override
    public int deleteEUserAddressById(Long id)
    {
        return eUserAddressMapper.deleteEUserAddressById(id);
    }
}
