package com.ruoyi.system.task;

import com.ruoyi.common.constant.ServiceConstants;
import com.ruoyi.system.order.domain.EOrderQuery;
import com.ruoyi.system.order.domain.EOrderVO;
import com.ruoyi.system.service.IEOrderOperService;
import com.ruoyi.system.order.service.IEOrderService;
import com.ruoyi.system.service.ISysConfigService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.List;

/**
 * 定时任务调度测试
 *
 * @author ruoyi
 */
@Slf4j
@Component("rlTask")
public class RlTask {


    @Resource
    private IEOrderService orderService;

    @Autowired
    private IEOrderOperService orderOperService;

    @Autowired
    private ISysConfigService configService;



    /**
     * 1.启动时判断是否有未取消预约的订单
     * 2.判断已完成的订单未退还押金的
     * 3.启动时判断是否分账
     */
    @Transactional
    @PostConstruct
    public void init() {
    }


    /**
     *  到过期时间后改变订单状态
     *  处理超时未支付订单
     */
    public void handleExpiredOrder(){
        log.info("-------------------【定时任务】处理过期订单---开始----------------");
        EOrderQuery rlOrderQuery = new EOrderQuery();
        rlOrderQuery.setPaid(ServiceConstants.ORDER_PAY_STATUS_NON_PAYMENT);
        List<EOrderVO> rlOrderVOS = orderService.selectAllRlOrderList(rlOrderQuery);
        for (EOrderVO orderVO:rlOrderVOS) {
            // 检查autoCancelTime是否已经过了当前时间
//            if (!orderVO.getIsOverdue() && orderVO.getAutoCancelTime().before(new Date())) {
//                EOrder rlOrder = new EOrder();
//                rlOrder.setOrderId(orderVO.getOrderId());
//                rlOrder.setStatus(ServiceConstants.ORDER_STATUS_AUTO_CANCEL);
//                int i = orderService.updateRlOrder(rlOrder);
//                if(i>0){
//                    if(!orderOperService.recordOrderHistory(orderVO.getOrderNo(),ServiceConstants.ORDER_OPERATION_SYSTEM_CANCEL,
//                            orderVO.getStatus(),rlOrder.getStatus(),orderVO.getPayFee(),orderVO.getPayFee(),orderVO.getUserId(),orderVO.getPhone(),"超时系统自动取消")){
//                        throw new ServiceException("【记录订单履历--超时系统自动取消失败】");
//                    }
//                }
//            }
        }
        log.info("-------------------【定时任务】处理过期订单---结束----------------");
    }

    /**
     *  超时过期时间的订单增加一个超时标记
     *  处理过期订单
     */
//    public void expiredMarkers(){
//        log.info("-------------------【定时任务】超时标记---开始----------------");
//        EOrderQuery rlOrderQuery = new EOrderQuery();
//        rlOrderQuery.setStatus(ServiceConstants.ORDER_STATUS_IN_USE);
//        List<EOrderVO> rlOrderVOS = orderService.selectAllRlOrderList(rlOrderQuery);
//        for (EOrderVO orderVO:rlOrderVOS) {
//            if(!orderVO.getIsOverdue()){
//                // 判断订单是否已过期，如果过期了，则标记为已过期
//                if (orderVO.getExpiryTime().before(new Date())) {
//                    EOrder rlOrder = new EOrder();
//                    rlOrder.setOrderId(orderVO.getOrderId());
//                    rlOrder.setIsOverdue(true);
//                    orderService.updateRlOrder(rlOrder);
//                }else {
//                    // 设定提前提醒的分钟数
//                    String s = configService.selectConfigByKey("rl.reminder.minutes");
//                    if(s==null|| s.equals("")){
//                        throw new ServiceException("【获取配置信息】rl.reminder.minutes未配置");
//                    }
//                    int reminderMinutes = Integer.parseInt(s);  // 例如，提前10分钟提醒
//                    // 计算距离过期时间还有多少分钟
//                    long diffInMillis = orderVO.getExpiryTime().getTime() - new Date().getTime();
//                    long diffInMinutes = diffInMillis / (60 * 1000); // 毫秒转分钟
//
//                    if (diffInMinutes <= reminderMinutes && !orderVO.getIsSendMsg()) {
//                        log.info("【定时任务】订单【{}】即将过期，距离过期还有{}分钟", orderVO.getOrderNo(), diffInMinutes);
//                        YPMsgUtils.expirationReminderMsg(orderVO.getOrderNo(),orderVO.getPhone(),DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM_SS, orderVO.getExpiryTime()));
//                        EOrder rlOrder = new EOrder();
//                        rlOrder.setOrderId(orderVO.getOrderId());
//                        rlOrder.setIsSendMsg(true);
//                        int i = orderService.updateRlOrder(rlOrder);
//                        if(i>0){
//                            log.info("【定时任务】订单【{}】标记已发送短信", orderVO.getOrderNo());
//                        }
//                    }
//                }
//            }
//        }
//        log.info("-------------------【定时任务】超时标记---结束----------------");
//    }

}
